//api.js
function httpRequest (url, timeout, headers, callback) { 
	timeout = (timeout === undefined) ? 30000 : timeout;
	var jxhr = $.ajax ({ 
		url: url,
		dataType: "text", 
		headers,
		timeout
		}) 
	.success (function (data, status) { 
		callback (undefined, data);
		}) 
	.error (function (status) { 
		var message;
		try { //9/18/21 by DW
			message = JSON.parse (status.responseText).message;
			}
		catch (err) {
			message = status.responseText;
			}
		if ((message === undefined) || (message.length == 0)) { //7/22/22 by DW & 8/31/22 by DW
			message = "There was an error communicating with the server.";
			}
		var err = {
			code: status.status,
			message
			};
		callback (err);
		});
	}
function addEmailParams (params) { //12/13/22 by DW
	try { //11/26/23 by DW
		if (globals.emailMemory !== undefined) { //12/22/22 by DW
			params.emailaddress = globals.emailMemory.emailaddress;
			params.emailcode = globals.emailMemory.code;
			}
		}
	catch (err) {
		}
	}
function getFeedlandServerAddress () { //6/7/23 by DW -- transitional glue
	if (appConsts.urlFeedlandServer !== undefined) {
		return (appConsts.urlFeedlandServer);
		}
	else {
		return (appConsts.urlTwitterServer);
		}
	}
function getActingAs (params) { //11/3/23 by DW
	if (localStorage.adminActingAs !== undefined) {
		if (localStorage.adminActingAs.length > 0) { //11/3/23 by DW
			params.actingas = localStorage.adminActingAs;
			}
		}
	}
function servercall (path, params, flAuthenticated, callback, urlServer=getFeedlandServerAddress ()) {
	var whenstart = new Date ();
	if (params === undefined) {
		params = new Object ();
		}
	if (flAuthenticated) { //1/11/21 by DW
		if (localStorage.twOauthToken !== undefined) { //12/23/22 by DW
			params.oauth_token = localStorage.twOauthToken;
			params.oauth_token_secret = localStorage.twOauthTokenSecret;
			}
		addEmailParams (params); //12/13/22 by DW
		}
	getActingAs (params); //11/3/23 by DW
	var url = urlServer + path + "?" + buildParamList (params, false);
	httpRequest (url, undefined, undefined, function (err, jsontext) {
		if (err) {
			console.log ("servercall: url == " + url + ", err.message == " + err.message);
			callback (err);
			}
		else {
			callback (undefined, JSON.parse (jsontext));
			}
		});
	}
function serverpost (path, params, flAuthenticated, filedata, callback) {
	var whenstart = new Date ();
	if (!$.isPlainObject (filedata) && (typeof (filedata) != "string")) { //8/2/21 by DW
		filedata = filedata.toString ();
		}
	if (params === undefined) {
		params = new Object ();
		}
	if (flAuthenticated) { //1/11/21 by DW
		if (localStorage.twOauthToken !== undefined) { //11/1/23 by DW
			params.oauth_token = localStorage.twOauthToken;
			params.oauth_token_secret = localStorage.twOauthTokenSecret;
			}
		addEmailParams (params); //12/13/22 by DW
		}
	getActingAs (params); //11/3/23 by DW
	var url = getFeedlandServerAddress () + path + "?" + buildParamList (params, false);
	$.post (url, filedata, function (data, status) {
		if (status == "success") {
			if (callback !== undefined) {
				callback (undefined, data);
				}
			}
		else {
			var err = {
				code: status.status,
				message: JSON.parse (status.responseText).message
				};
			if (callback !== undefined) {
				callback (err);
				}
			}
		});
	}
function deleteItem (id, callback) {
	servercall ("deleteitem", {id}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data); 
			}
		});
	}
function getFeedItem (id, callback) { //11/10/22 by DW
	servercall ("getitem", {id}, true, callback);
	}
function getFeed (url, callback) {
	servercall ("getfeed", {url}, true, function (err, feedRec) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, feedRec); 
			}
		});
	}
function getFollowers (feedUrl, callback) {
	servercall ("getfollowers", {url: feedUrl}, false, callback);
	}
function getLikes (id, callback) {
	servercall ("getlikes", {id}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data); 
			}
		});
	}
function toggleLike (id, callback) {
	servercall ("togglelike", {id}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data); 
			}
		});
	}
function subscribe (feedUrl, callback) {
	const params = {
		url: feedUrl
		};
	servercall ("subscribe", params, true, function (err, data) {
		if (callback !== undefined) {
			callback (err, data)
			}
		});
	}
function unsubscribe (feedUrl, callback) {
	servercall ("unsubscribe", {url: feedUrl}, true, function (err, data) {
		if (callback !== undefined) {
			callback (err, data)
			}
		});
	}
function unsubList (list, callback) {
	var jsontext = jsonStringify (list);
	servercall ("unsublist", {list: jsontext}, true, function (err, data) {
		if (callback !== undefined) {
			callback (err, data)
			}
		});
	}
function checkFeedOnServer (url, callback) {
	servercall ("checkfeednow", {url}, true, function (err, data) {
		if (err) {
			if (callback !== undefined) {
				callback (err);
				}
			}
		else {
			if (callback !== undefined) {
				callback (undefined, data); 
				}
			}
		});
	}
function getUpdatedFeed (url, callback) {
	servercall ("getupdatedfeed", {url}, true, function (err, theFeed) {
		if (err) {
			if (callback !== undefined) {
				callback (err);
				}
			}
		else {
			if (callback !== undefined) {
				callback (undefined, theFeed); 
				}
			}
		});
	}
function getFeedRec (url, callback) {
	servercall ("getfeedrec", {url}, true, function (err, feedRec) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, feedRec); 
			}
		});
	}
function getSubscription (feedUrl, urlReadingList, callback) {
	if (urlReadingList === undefined) {
		urlReadingList = "";
		}
	servercall ("isusersubscribed", {url: feedUrl, urlreadinglist: urlReadingList}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			if (data.flSubscribed) {
				var sub = data.theSubscription;
				if (sub.categories !== undefined) { //9/6/22 by DW
					sub.categories = JSON.parse (sub.categories);
					}
				callback (undefined, sub);
				}
			else {
				callback (undefined, undefined);
				}
			}
		});
	}
function getSubscriptions (screenname, callback) {
	servercall ("getusersubcriptions", {screenname}, false, function (err, theSubs) {
		if (err) {
			callback (err);
			}
		else {
			theSubs.forEach (function (sub) {
				if (sub.categories !== undefined) {
					sub.categories = JSON.parse (sub.categories);
					}
				});
			callback (undefined, theSubs);
			}
		});
	}
function userIsWhitelisted (callback) { //7/21/22 by DW
	servercall ("useriswhitelisted", undefined, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data.flWhitelisted); 
			}
		});
	}
function getRecentSubscriptions (callback) { //7/23/22 by DW
	servercall ("getrecentsubscriptions", undefined, true, function (err, theSubs) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, theSubs);
			}
		});
	}
function getHotlist (callback) { //7/30/22 by DW
	servercall ("gethotlist", undefined, false, callback);
	}
function getFeedSearch (searchfor, callback) { //12/26/22 by DW
	servercall ("getfeedsearch", {searchfor}, false, callback);
	}
function getTextFromWeb (url, callback) {
	readHttpFileThruProxy (url, undefined, function (theText) {
		if (theText === undefined) {
			callback ({message: "There was an error reading the file."});
			}
		else {
			callback (undefined, theText);
			}
		});
	}
function getOutlineFromWeb (url, callback) {
	httpRequest (url, undefined, undefined, function (err, opmltext) {
		if (err) {
			callback (err);
			}
		else {
			var theOutline;
			try {
				theOutline = opml.parse (opmltext);
				}
			catch (err) {
				callback (err);
				}
			callback (undefined, theOutline);
			}
		})
	}
function getOutlineFromWebThruProxy (opmlUrl, callback) { //10/30/23 by DW
	getTextFromWeb (opmlUrl, function (err, opmltext) {
		if (err) {
			callback (err);
			}
		else {
			var theOutline;
			try {
				theOutline = opml.parse (opmltext);
				}
			catch (err) {
				callback (err);
				return;
				}
			callback (undefined, theOutline);
			}
		});
	}
function getFeedItems (feedUrl, maxItems=5, callback) { //8/31/22 by DW
	const params = {
		url: feedUrl, 
		maxItems
		};
	servercall ("getfeeditems", params, false, callback);
	}
function setCategoriesForSubscription (feedUrl, categoriesArray, callback) { //9/4/22 by DW
	const params = {
		url: feedUrl, 
		jsontext: JSON.stringify (categoriesArray)
		};
	servercall ("setsubscriptioncategories", params, true, callback);
	}
function getFeedsInCategory (catname, callback) { //9/6/22 by DW
	servercall ("getfeedsincategory", {catname}, true, callback);
	}

function getRiverFromCategory (screenname, catname, callback) { //9/6/22 by DW
	servercall ("getriverfromcategory", {screenname, catname}, false, callback);
	}
function getRiverFromEverything (callback) { //10/14/22 by DW
	servercall ("getriverfromeverything", undefined, false, callback);
	}
function getRiverFromHotlist (callback) { //10/15/22 by DW
	servercall ("getriverfromhotlist", undefined, false, callback);
	}
function getRiverFromUserFeeds (callback) { //12/3/22 by DW
	servercall ("getriverfromuserfeeds", undefined, false, callback);
	}
function getRiverFromList (feedUrlList, callback) { //8/4/22 by DW
	var jsontext = JSON.stringify (feedUrlList);
	servercall ("getriverfromlist", {list: jsontext}, true, callback);
	}
function getRiver (feedUrl, screenname, callback) {
	if (Array.isArray (feedUrl)) { //it's a list of feed urls -- 8/4/22 by DW
		getRiverFromList (feedUrl, callback);
		}
	else {
		if (typeof feedUrl == "object") { //9/7/22 by DW
			if (feedUrl.screenname !== undefined) {
				getRiverFromCategory (feedUrl.screenname, feedUrl.catname, callback);
				}
			else {
				if (feedUrl.hotlist !== undefined) {
					getRiverFromHotlist (callback); //10/15/22 by DW
					}
				else {
					if (feedUrl.everything !== undefined) {
						getRiverFromEverything (callback); //10/14/22 by DW
						}
					else {
						if (feedUrl.userfeeds) { //12/3/22 by DW
							getRiverFromUserFeeds (callback); 
							}
						else {
							let message = "Internal error: Unknown river type.";
							callback ({message});
							}
						}
					}
				}
			}
		else {
			if (endsWith (stringLower (feedUrl), ".opml")) { //8/21/22 by DW
				servercall ("getriverfromopml", {url: feedUrl}, false, callback);
				}
			else {
				var params = {
					screenname
					}
				if (feedUrl !== undefined) {
					params.url = feedUrl;
					}
				
				
				servercall ("getriver", params, true, function (err, theRiver) {
					if (err) {
						callback (err);
						}
					else {
						callback (undefined, theRiver); 
						}
					});
				}
			}
		}
	}

function getUserCategories (screenname, callback) { //9/13/22 by DW
	if (screenname === undefined) { //10/29/22 by DW
		let message = "Can't get the categories because the name is not specified.";
		callback ({message});
		}
	else {
		servercall ("getusercategories", {screenname}, false, callback);
		}
	}
function getOneUserCategory (screenname, catname, callback) { //9/13/22 by DW
	servercall ("getfeedsincategory", {screenname, catname}, true, callback);
	}
function getAllUsers (callback) { //9/15/22 by DW
	const whenstart = new Date ();
	servercall ("getallusers", undefined, false, function (err, theUsers) {
		console.log ("getAllUsers: " + secondsSince (whenstart) + " secs."); //11/10/22 by DW
		callback (err, theUsers);
		});
	}
function feedlandPrefsUpload (callback) { //9/15/22 by DW
	const whenstart = new Date ();
	if (userIsSignedIn ()) {
		servercall ("sendprefs", {prefs: jsonStringify (appPrefs)}, true, function (err, data) {
			if (!err) { //8/20/23 by DW
				console.log ("feedlandPrefsUpload: " + secondsSince (whenstart) + " secs.");
				}
			if (callback !== undefined) {
				callback (err, data);
				}
			});
		}
	}
function getUserPrefs (callback) { //9/28/22 by DW
	servercall ("getuserprefs", undefined, true, callback);
	}
function getUserInfo (screenname, callback) { //11/10/23 by DW 
	servercall ("getuserinfo", {screenname}, false, callback); 
	}
function renewFeedNow (feedUrl, callback) { //10/9/22 by DW
	servercall ("renewfeednow", {url: feedUrl}, true, callback);
	}
function isFeedInRiver (url, cachekey, callback) { //2/1/23 by DW
	servercall ("isfeedinriver", {url, cachekey}, false, callback);
	}

function downloadFile (relpath, callback) {
	servercall ("readwholefile", {relpath}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data.filetext); 
			}
		});
	}
function updateBlogSettings (theSettings, callback) {
	var jsontext = jsonStringify (theSettings);
	servercall ("updateblogsettings", {jsontext}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data); 
			}
		});
	}
function newBlogPost (thePost, callback) {
	var jsontext = jsonStringify (thePost);
	servercall ("newblogpost", {jsontext}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data); 
			}
		});
	}
function updateBlogPost (thePost, callback) {
	var jsontext = jsonStringify (thePost);
	servercall ("updateblogpost", {jsontext}, true, function (err, data) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, data); 
			}
		});
	}

function sendConfirmingEmail (email, callback) { //12/7/22 by DW
	servercall ("sendconfirmingemail", {email}, false, callback);
	}
function regenerateEmailSecret (callback) { //12/26/22 by DW
	servercall ("regenerateemailsecret", undefined, true, callback);
	}
function isUserInDatabase (screenname, callback) { //1/6/23 by DW
	servercall ("isuserindatabase", {screenname}, false, function (err, data) {
		if (err) {
			callback (false);
			}
		else {
			callback (getBoolean (data.flInDatabase));
			}
		});
	}
function isEmailInDatabase (email, callback) { //1/12/23 by DW
	servercall ("isemailindatabase", {email}, false, function (err, data) {
		if (err) {
			callback (false);
			}
		else {
			callback (getBoolean (data.flInDatabase));
			}
		});
	}
function createNewUser (email, name, callback) { //1/7/23 by DW
	const params = { //7/4/23 by DW
		email, name,
		urlredirect: stringNthField (stringNthField (location.href, "?", 1), "#", 1)
		};
	servercall ("createnewuser", params, false, callback);
	}

function getUserDataFile (relpath, flIncludeBody, flPrivate, callback) { //replacement for twGetFile -- 12/23/22 by DW
	var params = {
		relpath
		}
	if (flIncludeBody) {
		params.flIncludeBody = "true";
		}
	if (flPrivate) {
		params.flprivate = true;
		}
	servercall ("getfile", params, true, callback);
	}
function uploadUserDataFile (relpath, filedata, type, flPrivate, callback) { //replacement for twUploadFile -- 12/23/22 by DW
	const whenstart = new Date ();
	var params = {
		relpath, type
		}
	if (flPrivate) {
		params.flprivate = true;
		}
	serverpost ("publishfile", params, true, filedata, function (err, data) {
		if (!err) {
			console.log ("uploadUserDataFile: relpath == " + relpath + ", " + secondsSince (whenstart) + " secs."); //8/20/23 by DW
			}
		if (callback !== undefined) {
			callback (err, data);
			}
		});
	}

function getFeedlistFromOpml (url, callback) {//6/2/23 by DW
	servercall ("getfeedlistfromopml", {url}, false, function (err, thePackage) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, thePackage.feedlist, thePackage.head);
			}
		});
	}

function checkReadingList (opmlUrl, callback) { //10/9/23 by DW
	servercall ("checkreadinglist", {url: opmlUrl}, false, callback);
	}
function subscribeToReadingList (opmlUrl, callback) { //10/9/23 by DW
	servercall ("subscribetoreadinglist", {url: opmlUrl}, true, callback);
	}
function getReadingListSubscriptions (screenname, callback) { //10/13/23 by DW
	servercall ("getreadinglistsubscriptions", {screenname}, false, function (err, theReadingLists) {
		if (err) {
			callback (err);
			}
		else {
			let flerror = false;
			theReadingLists.forEach (function (item) {
				if (typeof item.feedUrls == "string") { //10/23/23 by DW
					try {
						item.feedUrls = JSON.parse (item.feedUrls);
						}
					catch (err) {
						callback (err);
						flerror = true;
						}
					}
				});
			if (!flerror) {
				callback (undefined, theReadingLists);
				}
			}
		});
	}
function unsubReadingList (opmlUrl, callback) { //10/13/23 by DW
	servercall ("unsubreadinglist", {url: opmlUrl}, true, callback);
	}
function getReadingListsInfo (opmlUrlList, callback) { //10/19/23 by DW
	var jsontext = JSON.stringify (opmlUrlList);
	servercall ("getreadinglisstinfo", {jsontext}, false, callback);
	}
function getReadingListFollowers (opmlUrl, callback) { //10/28/23 by DW
	servercall ("getreadinglistfollowers", {url: opmlUrl}, false, callback);
	}
function checkMyReadingListSubs (opmlUrl, callback) { //12/13/23 by DW
	servercall ("checkmyreadinglistsubs", {url: opmlUrl}, true, callback);
	}


function testGetFeedItems () {
	getFeedItems ("http://scripting.com/rss.xml", undefined, function (err, theItems) {
		if (err) {
			console.log (err.message);
			}
		else {
			console.log (jsonStringify (theItems));
			}
		});
	}
function testUserDatafiles (ctsecs=0) { //9/19/23 by DW
	function oneTest (callback) {
		const fname = "test.json", whenstart = new Date ();
		var theTestData = {
			theArray: new Array ()
			}
		for (var i = 1; i <= 15; i++) {
			theTestData.theArray.push (getRandomSnarkySlogan ());
			}
		uploadUserDataFile (fname, jsonStringify (theTestData), "application/json", true, function (err, data) {
			if (err) {
				console.log ("testUserDatafiles: err.message == " + err.message);
				callback (false);
				}
			else {
				setTimeout (function () {
					getUserDataFile (fname, true, true, function (err, data) {
						if (err) {
							console.log ("testUserDatafiles: err.message == " + err.message);
							callback (false);
							}
						else {
							let savedTestdata, flGoodSave = true;
							try {
								savedTestdata = JSON.parse (data.filedata);
								}
							catch (err) {
								console.log ("testUserDatafiles: err.message == " + err.message);
								flGoodSave = false;
								}
							
							for (var i = 0; i <= 14; i++) {
								if (savedTestdata.theArray [i] != theTestData.theArray [i]) {
									console.log ("testUserDatafiles: the data doesn't match. i == " + i + ", original data == " + theTestData.theArray [i] + ", what we got back == " + savedTestdata.theArray [i]);
									flGoodSave = false;
									break;
									}
								}
							callback (flGoodSave);
							}
						});
					}, ctsecs * 1000);
				}
			});
		}
	
	console.log ("testUserDatafiles");
	oneTest (function (flworked) {
		if (flworked) {
			oneTest (function (flworked) {
				if (flworked) {
					console.log ("testUserDatafiles: everything checks out.");
					}
				});
			}
		});
	}
function testGetUserInfo (screenname="davewiner") {
	getUserInfo (screenname, function (err, theUser) {
		if (err) {
			console.log (err.message);
			}
		else {
			console.log (jsonStringify (theUser));
			}
		});
	}


//misc.js
//some of this stuff should eventually go into utils.js -- 8/28/22 by DW

function isMobileDevice () { //12/10/23 by DW
	const flMobile = window.innerWidth <= 576;
	return (flMobile);
	}
function removeScriptTags (theString) { //11/21/23 by DW
	if (theString === undefined) { //11/21/23 by DW
		return (undefined);
		}
	theString = theString.replace (/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi, "");
	return (theString);
	}
function neuterMarkup (theString) { //11/17/23 by DW
	if (theString === undefined) { //11/21/23 by DW
		return (undefined);
		}
	var temp = document.createElement ("div");
	temp.textContent = theString;
	return (temp.innerHTML);
	}
function isSupervisorMode () { //11/5/23 by DW
	if (localStorage.adminActingAs === undefined) {
		return (false);
		}
	else {
		return (localStorage.adminActingAs.length > 0);
		}
	}
function usingTwitterForIdentity () { //1/25/23 by DW
	return (appConsts.serverConfig.flUseTwitterIdentity)
	}
function isDave () {
	if (localStorage.isDave !== undefined) {
		if (localStorage.isDave == "true") {
			return (true);
			}
		}
	return (false);
	}
function isWordPressIdentity () { //11/13/23 by DW
	return (getBoolean (appConsts.flWordPressIdentityDefault));
	}
function userIsSignedIn () { //10/27/22 by DW
	if (appConsts.flUseTwitterIdentity) {
		try {
			return (twGetScreenName () !== undefined);
			}
		catch (err) {
			return (false);
			}
		}
	else {
		try {
			if (globals.emailMemory !== undefined) {
				return (true);
				}
			}
		catch (err) {
			return (false);
			}
		}
	}
function userIsAdmin () { //11/5/23 by DW
	var flAdmin = false;
	try {
		flAdmin = appPrefs.role == "admin"
		}
	catch (err) {
		}
	return (flAdmin);
	}
function getScreenName () { //12/23/22 by DW
	if (userIsSignedIn ()) {
		if (appConsts.flUseTwitterIdentity) {
			return (twGetScreenName ());
			}
		else {
			if (isSupervisorMode ()) { //11/5/23 by DW
				return (localStorage.adminActingAs);
				}
			else {
				return (globals.emailMemory.screenname); 
				}
			}
		}
	else {
		return (undefined);
		}
	}

function addToolTip (theObject, tipText, placement="right", flActivateNow=false) { //8/24/22 by DW
	$(theObject).attr ("data-container", "body"); //10/23/22 by DW
	$(theObject).attr ("data-toggle", "tooltip");
	$(theObject).attr ("data-placement", placement);
	$(theObject).attr ("title", tipText);
	$(theObject).click (function () { //11/1/22 by DW
		$(theObject).tooltip ("hide");
		});
	if (flActivateNow) { //2/19/24 by DW
		theObject.tooltip ();
		}
	return (theObject);
	}
function replaceToolTip (theObject, theTip, theParent, dir) { //10/15/22 by DW
	$(theObject).removeAttr ("data-toggle");
	$(theObject).removeAttr ("data-placement");
	$(theObject).removeAttr ("title");
	addToolTip (theObject, theTip, theParent, dir);
	}
function activateToolTips () { //8/28/22 by DW
	$("[data-toggle=\"tooltip\"]").tooltip ();
	}
function twitterUserLink (username, flTwitterIcon=false) { //4/6/19 by DW
	const linktext = (flTwitterIcon) ? twStorageConsts.fontAwesomeIcon : username;
	return ("<a class=\"aTwitterUserLink\" href=\"https://twitter.com/" + username + "\">" + linktext + "</a>");
	}
function linkToRiverPage (username, catname) { //10/8/22 by DW
	var url = "/?river=true&screenname=" + username;
	if (catname !== undefined) { //10/6/23 by DW
		url += "&catname=" + encodeURIComponent (stringLower (catname));
		}
	return ("<a class=\"aTwitterUserLink\" href=\"" + url + "\">" + username + "</a>");
	}
function linkToFeedList (username) { //10/8/22 by DW
	var url = "/?username=" + username;
	return ("<a class=\"aTwitterUserLink\" href=\"" + url + "\">" + username + "</a>");
	}
function getOpmlLink (urlOpml, tooltipText) {
	var xmlIcon = $("<div class=\"divOpmlLink\"><a href=\"" + urlOpml + "\" target=\"_blank\"><div class=\"divXmlIcon\">XML</div></a></div>"); 
	addToolTip (xmlIcon, tooltipText);
	return (xmlIcon);
	}
function getExplainText (title, description, urlForTitle) {
	
	
	if (urlForTitle !== undefined) {
		title = "<a href=\"" + urlForTitle + "\">" + title + "</a>";
		}
	
	var titletext = "";
	const flShowBigTitle = (appPrefs.flShowBigTitle === undefined) ? true : appPrefs.flShowBigTitle;
	if (flShowBigTitle) { //10/8/22 by DW & 6/7/23 by DW
		titletext = "<h1>" + title + "</h1>";
		}
	
	description = (description === undefined) ? "&nbsp;" : description; //11/28/23 by DW
	
	var theText = $("<div class=\"divExplainText\">" + titletext + "<p>" + description + "</p></div>");
	return (theText);
	}
function getAllCatsArray () {
	var catsArray = new Array ();
	
	var prefsText = trimWhitespace (appPrefs.usersCategoryList);
	if (prefsText.length == 0) {
		prefsText = "All";
		}
	
	const splits = prefsText.split (",");
	splits.forEach (function (item) {
		catsArray.push (trimWhitespace (item));
		});
	return (catsArray);
	}

function chooseCategoriesDialog (theFeedList, ixFeed, tag, saveCallback) { //9/4/22 by DW
	var theFeed = theFeedList [ixFeed];
	var inputArray, theModalBody, thePrompt; //we need to change these when switching to a new feed
	
	console.log ("chooseCategoriesDialog: theFeedList.length == " + theFeedList.length + ", ixFeed == " + ixFeed);
	
	function getPromptText () {
		var theDiv = $("<div class=\"divPrompt\"></div>");
		
		var theText = $("<span class=\"spFeedTitle\">" + maxStringLength (theFeed.title, 30, false, true) + "</span>");
		var description = (theFeed.description === undefined) ? "[no description]" : theFeed.description;
		addToolTip (theText, description, "bottom");
		theText.tooltip (); 
		theDiv.append (theText);
		
		console.log ("getPromptText: description == " + description); //7/29/23 by DW -- the tooltip is broken, at least let me see it in the console 
		
		return (theDiv);
		}
	function isChecked (catstring) {
		var flchecked = false;
		if (theFeed.categories !== undefined) { //the first time you open the dialog, the cats setting for all is 
			catstring = stringLower (catstring);
			theFeed.categories.forEach (function (item) {
				if (stringLower (item) == catstring) { //the category is present
					flchecked = true;
					}
				});
			}
		return (flchecked);
		}
	function getCloseIcon () {
		var theIcon = $("<a href=\"#\" class=\"close\" data-dismiss=\"modal\">&times;</a>");
		$(theIcon).click (cancelDialog);
		return (theIcon);
		}
	function getPrompt () {
		thePrompt = $("<div></div>");
		thePrompt.append (getPromptText ());
		return (thePrompt);
		}
	function getCloseButton () {
		const theButton = $("<a href=\"#\" class=\"btn\" style=\"width: 60px; margin-left: 10px;\">Close</a>");
		$(theButton).click (function () {
			closeDialog ();
			});
		return (theButton);
		}
	function getEditButton () { //11/27/23 by DW
		const theButton = $("<a href=\"#\" class=\"btn\" style=\"width: 60px; margin-left: 10px;\">Edit</a>");
		$(theButton).click (function () {
			askDialog ("Edit the list of categories:", appPrefs.usersCategoryList, "", function (newCategoryList, flcancel) {
				if (!flcancel) {
					alert (newCategoryList);
					}
				});
			});
		return (theButton);
		}
	function getOkButton () {
		var theButton = $("<a href=\"#\" class=\"btn btn-primary\" style=\"width: 80px; margin-left: 5px;\">OK</a>");
		$(theButton).click (okDialog);
		return (theButton);
		}
	function getCheckedCatsArray () {
		var theArray = new Array (), allCatsArray = getAllCatsArray ();
		inputArray.forEach (function (theInput, ix) {
			var flChecked = theInput.prop ("checked"); 
			if (flChecked) {
				theArray.push (allCatsArray [ix]);
				}
			});
		return (theArray);
		}
	function saveCategories () { 
		theFeed.categories = getCheckedCatsArray ();
		console.log ("saveCategories: theFeed.feedUrl == " + theFeed.feedUrl + ", theFeed.categories == " + jsonStringify (theFeed.categories));
		setCategoriesForSubscription (theFeed.feedUrl, theFeed.categories, function (err, theSubscription) {
			if (err) {
				alert (err.message);
				}
			else {
				if (tag !== undefined) { //9/12/22 by DW
					if (emptyCategories (theFeed.categories)) {
						tag.removeClass ("darkCategorySelector");
						}
					else {
						tag.addClass ("darkCategorySelector");
						}
					}
				if (saveCallback !== undefined) { //9/12/22 by DW
					saveCallback (theFeed);
					}
				}
			});
		}
		
	function getTable () {
		var theTable = $("<table class=\"tableForCategories\"></table>");
		var catsArray = getAllCatsArray ();
		inputArray = new Array ();
		catsArray.forEach (function (catstring) {
			var theRow = $("<tr></tr>");
			var tdCheckbox = $("<td></td>");
			var theInput = $("<input type=\"checkbox\">");
			theInput.prop ("checked", isChecked (catstring)); //should have the value of cats for the feed
			theInput.click (function (ev) {
				saveCategories ();
				});
			inputArray.push (theInput); 
			tdCheckbox.append (theInput);
			theRow.append (tdCheckbox);
			theRow.append ($("<td class=\"tdCatstring\">" + catstring + "</td>"));
			theTable.append (theRow);
			});
		return (theTable);
		}
	
	function getExplanation () {
		var div = $("<div class=\"divCategoriesExplanation\">Your categories for this feed.</div>");
		addToolTip (div, "The checkboxes are hot, they change in the database when you click.", "bottom");
		div.tooltip ();
		return (div);
		}
	
	function switchFeed (ixNewFeed) {
		ixFeed = ixNewFeed;
		theFeed = theFeedList [ixFeed];
		
		thePrompt.html (getPromptText ());
		
		theModalBody.empty ();
		theModalBody.append (getTable ());
		}
	function getArrows () {
		var arrows = $("<div class=\"divCategoryArrows\"></div>");
		var leftarrow = $("<span><i class=\"fa fa-arrow-left\"></i></span>");
		var rightarrow = $("<span><i class=\"fa fa-arrow-right\"></i></span>");
		arrows.append (leftarrow);
		arrows.append (rightarrow);
		$(leftarrow).click (function (ev) {
			if (ixFeed == 0) {
				speakerBeep ();
				}
			else {
				switchFeed (ixFeed - 1);
				}
			});
		$(rightarrow).click (function (ev) {
			if (ixFeed >= theFeedList.length) {
				speakerBeep ();
				}
			else {
				switchFeed (ixFeed + 1);
				}
			});
		return (arrows);
		}
	function closeDialog () {
		$(theDialog).modal ("hide"); 
		$(theDialog).on ("hidden.bs.modal", function () { //code that runs when dialog has finished being hidden
			$(theDialogContainer).remove ();
			});
		}
	function cancelDialog () {
		closeDialog ();
		}
	function getCatsString () {
		var theArray = new Array ();
		inputArray.forEach (function (theInput, ix) {
			var flChecked = theInput.prop ("checked"); 
			if (flChecked) {
				theArray.push (catsArray [ix]);
				}
			});
		return (JSON.stringify (theArray));
		}
	function okDialog () {
		theFeed.categories = getCheckedCatsArray ();
		console.log ("chooseCategoriesDialog: theFeed.categories == " + JSON.stringify (theFeed.categories));
		setCategoriesForSubscription (theFeed.feedUrl, theFeed.categories, function (err, theSubscription) {
			if (err) {
				alert (err.message);
				}
			else {
				closeDialog ();
				if (tag !== undefined) { //9/12/22 by DW
					if (theFeed.categories.length > 0) {
						tag.addClass ("darkCategorySelector");
						}
					else {
						tag.removeClass ("darkCategorySelector");
						}
					}
				}
			});
		}
	
	var theDialogContainer = $("<div class=\"divCategoriesDialog\"></div>");
	var theDialog = $("<div class=\"modal hide fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"windowTitleLabel\" aria-hidden=\"true\"></div>");
	
	var theHeader = $("<div class=\"modal-header\"></div>");
	$(theHeader).append (getCloseIcon ());
	$(theHeader).append (getPrompt ());
	$(theDialog).append (theHeader);
	
	theModalBody = $("<div class=\"modal-body\"></div>");
	theModalBody.append (getTable ());
	theDialog.append (theModalBody);
	
	var theFooter = $("<div class=\"modal-footer\"></div>");
	$(theFooter).append (getArrows ());
	
	
	if (isDave ()) { //11/27/23 by DW
		$(theFooter).append (getEditButton ());
		}
	
	$(theFooter).append (getCloseButton ());
	$(theDialog).append (theFooter);
	
	$(theDialogContainer).append (theDialog);
	$("body").prepend (theDialogContainer);
	$(theDialog).modal ("show");
	
	$(theDialog).on ("keydown", function (ev) { 
		if (ev.which == 13) {
			console.log ("you pressed return");
			okDialog ();
			}
		});
	}

function viewDataDialog (title="", theData) {
	
	function afterOpenCallback () {
		opInsertObject ("", theData, down);
		opGo (up, 1);
		opDeleteLine ();
		opExpand (1);
		}
	
	const options = {
		title: "FeedLand item data",
		flReadOnly: true,
		outlineFontSize: 15,
		outlineLineHeight: 22,
		whereToAppend: $("body"), 
		divDialogStyles: "divDataDialog",
		opmltext: undefined,
		afterOpenCallback
		};
	outlineDialog (options);
	}

function myAskDialog (prompt, defaultvalue, placeholder, askcallback, typeparam) {
	
	return (askDialog (prompt, defaultvalue, placeholder, askcallback, typeparam)); //10/21/22 by DW
	
	function closeDialog () {
		$(theDialog).modal ("hide"); 
		$(theDialog).on ("hidden.bs.modal", function () { //code that runs when dialog has finished being hidden
			$(theDialogContainer).remove ();
			});
		}
	function cancelDialog () {
		if (askcallback !== undefined) {
			askcallback ("", true); 
			}
		closeDialog ();
		}
	function okDialog () { //ok button was clicked
		if (askcallback !== undefined) {
			var val = theInputElement.val ();
			askcallback (val, false); 
			}
		closeDialog ();
		}
	function getCloseIcon () {
		var theIcon = $("<a href=\"#\" class=\"close\" data-dismiss=\"modal\">&times;</a>");
		$(theIcon).click (cancelDialog);
		return (theIcon);
		}
	function getPrompt () {
		var promptText = "";
		if (prompt !== undefined) {
			promptText = prompt;
			}
		var thePrompt = $("<h3 style=\"font-size: 18px;\">" + promptText + "</h3>");
		return (thePrompt);
		}
	function getInputElement () {
		var valueatt = "";
		if (defaultvalue !== undefined) {
			valueatt = "value=\"" + defaultvalue + "\"";
			}
		
		var placeholderAtt = "";
		if (placeholder !== undefined) {
			placeholderAtt = "placeholder=\"" + placeholder + "\"";
			}
		
		var typeatt = "type=\"text\"";
		if (typeparam !== undefined) {
			typeatt = "type=\"" + typeparam + "\"";
			}
		
		var theElement = $("<input class=\"xlarge\" " + valueatt + placeholderAtt + typeatt + " name=\"xlInput\" style=\"font-size: 17px; padding: 3px; height: auto; width: 515px;\" />");
		
		return (theElement);
		}
	function getCancelButton () {
		var theButton = $("<a href=\"#\" class=\"btn\" style=\"width: 80px; margin-left: 5px;\">Cancel</a>");
		$(theButton).click (cancelDialog);
		return (theButton);
		}
	function getOkButton () {
		var theButton = $("<a href=\"#\" class=\"btn btn-primary\" style=\"width: 80px; margin-left: 5px;\">OK</a>");
		$(theButton).click (okDialog);
		return (theButton);
		}
	
	var theDialogContainer = $("<div class=\"divAskDialog\" style=\"left: 50%; width: 570px;\"></div>");
	var theDialog = $("<div class=\"modal hide fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"windowTitleLabel\" aria-hidden=\"true\"></div>");
	
	var theHeader = $("<div class=\"modal-header\"></div>");
	$(theHeader).append (getCloseIcon ());
	$(theHeader).append (getPrompt ());
	$(theDialog).append (theHeader);
	
	var theBody = $("<div class=\"modal-body\"></div>");
	var theInputElement = getInputElement (); 
	theBody.append (theInputElement);
	$(theDialog).append (theBody);
	
	var theFooter = $("<div class=\"modal-footer\"></div>");
	$(theFooter).append (getCancelButton ());
	$(theFooter).append (getOkButton ());
	$(theDialog).append (theFooter);
	
	$(theDialogContainer).append (theDialog);
	$("body").prepend (theDialogContainer);
	$(theDialog).modal ("show");
	
	$(theDialog).on ("shown", function () {
		theInputElement.focus ();
		theInputElement.select ();
		});
	$(theDialog).on ("keydown", function (ev) { 
		if (ev.which == 13) {
			console.log ("you pressed return");
			okDialog ();
			}
		});
	}

function myAlertDialog (prompt, callback) {
	
	return (alertDialog (prompt, callback));
	
	console.log ("myAlertDialog");
	var divAlertDialog = $("<div class=\"modal hide fade divAlertDialog\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"windowTitleLabel\" aria-hidden=\"true\"></div>");
	var img = $("<img src=\"http://static.scripting.com/larryKing/images/2013/04/13/alert.gif\">");
	var divPrompt = $("<div class=\"divPrompt\"></div>");
	var divButton = $("<a href=\"#\" class=\"btn btn-primary\" id=\"idAlertDialogOkButton\">OK</a>");
	divAlertDialog.append (img);
	divAlertDialog.append (divPrompt);
	divAlertDialog.append (divButton);
	$("body").prepend (divAlertDialog);
	$(divPrompt).html (prompt);
	$(divButton).click (function () {
		$(divAlertDialog).modal ("hide");
		if (callback !== undefined) {
			callback ();
			}
		});
	$(divAlertDialog).on ("changePrompt", function (event, thePrompt) {
		$(divPrompt).html (thePrompt);
		});
	$(divAlertDialog).on ("changeButton", function (event, theButtonString) {
		$(divButton).html (theButtonString);
		});
	$(divAlertDialog).modal ("show");
	return (divAlertDialog);
	}

function getUrlParam (name) { //11/15/21 by DW
	var val = getURLParameter (name);
	if (val == "null") {
		return (undefined);
		}
	else {
		return (neuterAndDecode (val)); //12/11/23 by DW
		}
	}
function neuterAndDecode (theString) { //12/11/23 by DW
	const neutered = neuterMarkup (theString);
	const decoded = decodeURIComponent (neutered);
	return (decoded);
	}
function getFirstUrlParam (paramval, searchstring) {//5/26/22 by DW
	var s = searchstring;
	if (beginsWith (s, "?")) {
		s = stringDelete (s, 1, 1);
		}
	var param1 = stringNthField (s, "&", 1);
	if (param1.length == 0) {
		return ("");
		}
	
	const name = stringNthField (param1, "=", 1); //9/10/23 by DW
	
	var val = neuterAndDecode (stringDelete (param1, 1, name.length + 1));
	paramval.val = val;
	
	return (trimWhitespace (name));
	}

function getAllUrlParams (searchstring) { //9/7/22 by DW
	var s = searchstring;
	var allparams = new Object ();
	if (beginsWith (s, "?")) {
		s = stringDelete (s, 1, 1);
		}
	var splits = s.split ("&");
	splits.forEach (function (item) {
		const splits = item.split ("="); //9/10/23 by DW
		const name = splits [0];
		
		var val = neuterAndDecode (stringDelete (item, 1, name.length + 1)); //12/11/23 by DW
		allparams [trimWhitespace (name)] = val;
		});
	return (allparams);
	}

function getFeedlandTimeString (when, flLongStrings=false) {
	const options = {
		flBriefYearDates: true,
		nowString: "now",
		flUseYesterdayString: false //2/10/24 by DW
		};
	var s = getFacebookTimeString (when, flLongStrings, options);
	return (s);
	}
function getUpdateableTime (when, flTextAtEnd=".", flLongString=true, link) { //8/28/22 by DW
	var theWhen = $("<span class=\"spUpdateableTime\"></span>");
	function setWhen () {
		var whenstring = getFeedlandTimeString (when, flLongString) + flTextAtEnd;
		if (link !== undefined) { //9/1/22 by DW
			whenstring = "<a href=\"" + link + "\" target=\"_blank\">" + whenstring + "</a>";
			}
		if (theWhen.html () != whenstring) { //avoid flashing in the debugger, it's annoying
			theWhen.html (whenstring);
			}
		}
	setWhen ();
	theWhen.on ("update", setWhen);
	return (theWhen);
	}
function isInclude (theNode) {
	try {
		if (theNode.type == "include") {
			if (theNode.url !== undefined) {
				return (true);
				}
			}
		}
	catch (err) {
		}
	return (false);
	}


function xmlViewerUrl (url) {
	
	return (url); //11/27/23 by DW
	
	var urlReaderApp = (appPrefs.urlReaderApp === undefined) ? "http://xmlviewer.scripting.com/?url=" : appPrefs.urlReaderApp;
	url = urlReaderApp + encodeURIComponent (url);
	return (url);
	}
function xmlViewerLink (url, val) {
	if (val === undefined) {
		val = url;
		}
	return ("<a href=\"" + xmlViewerUrl (url) + "\" title=\"" + url+ "\" target=\"_blank\">" + val + "</a>");
	}
function markdownProcess (s) {
	var md = new Markdown.Converter ();
	return (md.makeHtml (s));
	}
function getTitleForDebugging (feedItem, maxlen=40) {
	var title = "";
	if (feedItem.title !== undefined) {
		title = feedItem.title;
		}
	else {
		if (feedItem.description !== undefined) {
			title = feedItem.description;
			}
		}
	title = maxStringLength (stripMarkup (title), maxlen, true, true);
	return (title);
	}

function formatDateTime (d) {
	d = new Date (d);
	return (d.toLocaleDateString () + " at " + d.toLocaleTimeString (undefined, {hour: "2-digit", minute: "2-digit"}));
	}

function feedNotInDatabase (theFeed) { //6/3/23 by DW
	const flFeedInDatabase = theFeed.whenCreated !== undefined;
	return (!flFeedInDatabase);
	}

function userIsSubscribed (feedUrl) { 
	if (globals.userSubscriptions === undefined) {
		return (false);
		}
	else {
		var flSubscribed = false;
		globals.userSubscriptions.forEach (function (item) {
			if (item.feedUrl == feedUrl) {
				if (item.flUnsubbed === undefined) {
					flSubscribed = true;
					}
				else {
					if (!item.flUnsubbed) {
						flSubscribed = true;
						}
					}
				}
			});
		return (flSubscribed);
		}
	}

function readFeed (url, callback) {
	servercall ("returnjson", {url}, true, function (err, theFeed) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, theFeed); 
			}
		});
	}
function getItemsDirectlyFromFeed (feedUrl, callback) { //5/19/22 by DW
	readFeed (feedUrl, function (err, theFeed) {
		if (err) {
			callback (err);
			}
		else {
			callback (undefined, theFeed.items);
			}
		});
	}

function boldenTitlelessText (theText) { //12/15/23 by DW
	const maxCharsInBold = Infinity; //disable feature
	function bolden (s) {
		return ("<b>" + s + "</b>");
		}
	function notWordChar (ch) {
		if (isAlpha (ch)) {
			return (false);
			}
		if (isNumeric (ch)) {
			return (false);
			}
		return (true);
		}
	if (false) { //(theText.length <= maxCharsInBold) {
		return (bolden (theText));
		}
	else {
		function scanPastMarkup (theText, callback) {
			var ix = 0, flInElement = false, ct = 0, watchthis = "";
			function movePastRightAngleBracket () {
				while (true) {
					if (ix > (theText.length - 1)) {
						break;
						}
					if (theText [ix++] == ">") {
						break;
						}
					}
				}
			while (true) {
				if (ix > (theText.length - 1)) { //we've run out of chars
					break;
					}
				var ch = theText [ix++];
				if (ch == "<") {
					movePastRightAngleBracket ();
					}
				else {
					if (!callback (ix, ++ct)) {
						break;
						}
					}
				watchthis = stringMid (theText, 1,  ix + 1);
				}
			return (stringMid (theText, 1, ix));
			}
		var firstPart = scanPastMarkup (theText, function (ix, ct) { //get the first maxCharsInBold non-markup chars
			if (ct >= maxCharsInBold) { //stop the scan
				return (false);
				}
			else {
				return (true); //continue
				}
			});
		var flDone = false;
		scanPastMarkup (firstPart, function (ix, ct) { //scan forward to find end of sentence, stop there
			if ((firstPart [ix] == " ") && (firstPart [ix - 1] == ".")) {
				firstPart = stringMid (firstPart, 1, ix);
				flDone = true;
				return (false);
				}
			else {
				return (true);
				}
			});
		if (!flDone) { //scan back from the end for the first non-word char, a space, punctuation, >
			for (var i = firstPart.length - 1; i >= 0; i--) {
				ch = firstPart [i];
				if (notWordChar (ch)) {
					firstPart = stringMid (firstPart, 1, i);
					break;
					}
				}
			}
		}
	const newText = bolden (firstPart) + theText.slice (firstPart.length);
	return (newText);
	}

function doRedirect (urlToRedirectTo) { //9/2/23 by DW
	console.log ("doRedirect: urlToRedirectTo == " + urlToRedirectTo);
	location.href = urlToRedirectTo;
	}

function getAppLink (partialUrl) { //11/24/23 by DW
	return ("https://feedland.com/");
	}


//subscriptionlog.js

function getUsersSubscriptionList (callback) { //7/27/22 by DW
	function sortSubs (theSubs) { //10/29/23 by DW
		var sortedSubs = new Object ();
		theSubs.forEach (function (item) {
			item.categories.forEach (function (catname) {
				if (sortedSubs [catname] === undefined) {
					sortedSubs [catname] = 1;
					}
				else {
					sortedSubs [catname]++;
					}
				});
			});
		return (sortedSubs);
		}
	if (userIsSignedIn ()) {
		if (globals.userSubscriptions === undefined) {
			const whenstart = new Date ();
			getSubscriptions (getScreenName (), function (err, theSubs) {
				if (err) {
					callback (err);
					}
				else {
					globals.userSubscriptions = theSubs;
					globals.sortedSubs = sortSubs (theSubs); //10/29/23 by DW
					callback (undefined, theSubs);
					console.log ("getUsersSubscriptionList: " + secondsSince (whenstart) + " secs.");
					}
				});
			}
		else {
			callback (undefined, globals.userSubscriptions);
			}
		}
	else {
		let message = "Can't get the subscriptions because you aren't signed in.";
		callback ({message});
		}
	}

function makeSureUserIsSubscribed (feedUrl) { //11/5/22 by DW
	if (!userIsSubscribed (feedUrl)) {
		if (globals.userSubscriptions === undefined) {
			globals.userSubscriptions = new Array ();
			}
		globals.userSubscriptions.push ({
			feedUrl
			});
		}
	}

function markAsUnsubscribed (feedUrl) { //8/29/22 by DW
	globals.userSubscriptions.forEach (function (item) {
		if (item.feedUrl == feedUrl) {
			item.flUnsubbed = true;
			}
		});
	}
function markAsSubscribed (feedUrl) { //8/29/22 by DW
	globals.userSubscriptions.forEach (function (item) {
		if (item.feedUrl == feedUrl) {
			if (item.flUnsubbed !== undefined) {
				delete item.flUnsubbed;
				}
			}
		});
	}
function emptyCategories (theCategoryArray) {
	if ((theCategoryArray === undefined) || (theCategoryArray.length == 0)) {
		return (true);
		}
	else {
		return (false);
		}
	}
function getFeedTitleCell (theFeed) {
	var titleString = maxStringLength (theFeed.title, 40, true, true);
	titleString = trimWhitespace (titleString); //12/2/19 by DW
	if (titleString.length == 0) {
		titleString = "[empty]";
		}
	var theTd = $("<td class=\"tdFeedTitle\"></td>");
	
	var theLink;
	if (false) { //(feedNotInDatabase (theFeed)) { //6/3/23 by DW & 6/8/23 by DW
		theLink = $("<span>" + titleString + "</span>");
		}
	else {
		var readingListPart = ""; //10/23/23 by DW
		if (theFeed.urlReadingList !== undefined) {
			readingListPart = "&urlreadinglist=" + encodeURIComponent (theFeed.urlReadingList);
			}
		theLink = $("<span><a href=\"?feedurl=" + encodeURIComponent (theFeed.feedUrl) + readingListPart + "\">" + titleString + "</a></span>");
		}
	
	if (theFeed.description !== undefined) {
		addToolTip (theLink, theFeed.description);
		}
	
	if (theFeed.urlReadingList !== undefined) { //10/11/23 by DW
		theLink.addClass ("spReadingListTitleStyle");
		}
	
	theTd.append (theLink);
	
	
	return (theTd);
	}
function getFeedSubscriberCell (theFeed) {
	return ($ ("<td class=\"tdFeedSubscriber\"><a href=\"/?username=" + encodeURIComponent (theFeed.subscriber) + "\">" + theFeed.subscriber + "</td>"));
	}
function getWhenUpdatedCell (when, theFeed) {
	if (when === undefined) { //6/2/23 by DW
		return ($ ("<td class=\"tdFeedUpdated\"></td>"));
		}
	else {
		var td = $ ("<td class=\"tdFeedUpdated\">" + getFeedlandTimeString (when) + "</td>")
		$(td).on ("update", function (event) {
			var theString = getFeedlandTimeString (when);
			$(td).text (theString);
			});
		return (td);
		}
	}
function getCheckboxCell (theFeed, checkboxClickCallback) {
	var theTableCell = $("<td class=\"tdFeedCheckbox\"></td>");
	if (userIsSignedIn ()) {
		var theCheckbox = $("<input type=\"checkbox\">");
		$(theTableCell).append (theCheckbox);
		$(theCheckbox).prop ("checked", userIsSubscribed (theFeed.feedUrl));
		$(theCheckbox).click (function (ev) {
			var flChecked = $(theCheckbox).prop ("checked"); //reflects the new state of checkbox
			if (flChecked) { 
				subscribe (theFeed.feedUrl);
				markAsSubscribed (theFeed.feedUrl); //8/29/22 by DW
				}
			else {
				unsubscribe (theFeed.feedUrl);
				markAsUnsubscribed (theFeed.feedUrl); //8/29/22 by DW
				}
			
			if (checkboxClickCallback !== undefined) { //6/3/23 by DW
				checkboxClickCallback ();
				}
			});
		}
	else {
		let virtualCheckbox = $("<div class=\"divVirtualCheckbox\"></div>");
		$(virtualCheckbox).click (function (ev) {
			speakerBeep ();
			});
		$(theTableCell).append (virtualCheckbox);
		}
	return (theTableCell);
	}

function viewSubscriptionLog () {
	const pageTitle = "Subscription log", pageDescription = "A list of newly-subscribed-to feeds.";
	console.log ("viewSubscriptionLog");
	getRecentSubscriptions (function (err, theSubscriptions) {
		if (err) {
			myAlertDialog (err.message);
			}
		else {
			var theContainer = $ ("<div class=\"divSubscriptionLogContainer\"></div>");
			var theLog = $("<div class=\"divSubscriptionLog\"></div>");
			theLog.append (getExplainText (pageTitle, pageDescription));
			var theTable = $("<table class=\"table\"></table>");
			theSubscriptions.forEach (function (item, rownum) {
				var theRow = $("<tr></tr>");
				function appendCell (theObject) {
					if (theObject !== undefined) {
						theRow.append (theObject);
						}
					}
				function getFeedNumberCell () {
					}
				appendCell (getFeedNumberCell ());
				appendCell (getCheckboxCell (item));
				appendCell (getFeedTitleCell (item));
				appendCell (getFeedSubscriberCell (item));
				appendCell (getWhenUpdatedCell (item.when, item));
				theTable.append (theRow);
				});
			theLog.append (theTable);
			theContainer.append (theLog);
			$(".divSignedOn").empty ();
			$(".divSignedOn").append (theContainer);
			activateToolTips (); //8/28/22 by DW
			}
		});
	}


//viewfeedlist.js
var currentFeedlist;
var readingListCache = new Object (); //10/29/23 by DW

function viewFeedlist (theList, userOptions) {
	var ixRowCursor = 0, theCursorRow, theRowArray = new Array (), savedCursorUrl = undefined; //12/27/22 by DW
	const rightCaret = "<i class=\"fa fa-caret-right feedListCaret darkCaretColor\"></i>";
	const downCaret = "<i class=\"fa fa-caret-down feedListCaret lightCaretColor\"></i>";
	var divFeedList; //9/23/22 by DW
	var restorableItems; //9/3/22 by DW
	var options = { //12/15/20; by DW
		maxItems: Infinity,
		sortBy: "whenUpdated", 
		flReverseSort: true, //sort from z to a instead of a to z -- 7/11/22 by DW
		mySubs: undefined,
		flCheckboxes: true,
		flSubsCount: true,
		flFeedNumbering: false,
		title: "",
		description: "",
		flWhenColumn: true, //the hotlist doesn't display this column -- 7/30/22 by DW
		opmlUrlName: undefined, //7/30/22 by DW
		opmlUrlSpecial: undefined, 
		whereToAppend: undefined, //10/12/22 by DW
		catname: undefined, //10/12/22 by DW
		flIncludeExplain: true, //12/26/22 by DW
		searchbox: undefined, 
		flOpmlLink: true,
		flAddFeedButton: true,
		flHandleNavigationKeystrokes: true, //12/28/22 by DW
		urlForOpmlLink: undefined, //6/2/23 by DW
		thisFeedHasNoItemsString: "This feed has no items.",
		extraContainerClass: undefined //12/7/23 by DW
		};
	
	function scrollToMakeVisible (obj) { //12/27/22 by DW
		obj [0].scrollIntoView ({
			behavior: "smooth", 
			block: "nearest"
			});
		}
	function getRownum (feedUrl) { 
		var rownum = 0;
		theRowArray.forEach (function (item, ix) {
			if (item.attr ("data-feedurl") == feedUrl) {
				rownum = ix;
				}
			});
		return (rownum);
		}
	function moveCursorTo (rownum) { 
		if (options.flHandleNavigationKeystrokes) {
			const className = "trFeedCursor";
			if (theCursorRow !== undefined) {
				theCursorRow.removeClass (className);
				}
			theCursorRow = theRowArray [rownum];
			theCursorRow.addClass ("trFeedCursor");
			scrollToMakeVisible (theCursorRow);
			ixRowCursor = rownum;
			}
		}
	function moveCursorUp () {
		if (ixRowCursor <= 0) {
			speakerBeep ();
			}
		else {
			moveCursorTo (ixRowCursor - 1);
			}
		}
	function moveCursorDown () {
		if (ixRowCursor >= (theRowArray.length - 1)) {
			speakerBeep ();
			}
		else {
			moveCursorTo (ixRowCursor + 1);
			}
		}
	function toggleExpand () {
		var theRow = theRowArray [ixRowCursor];
		theRow.children (".tdWedge").click ();
		}
	
	function saveCursor () {
		savedCursorUrl = theCursorRow.attr ("data-feedurl");
		}
	function restoreCursor () {
		ixRowCursor = getRownum (savedCursorUrl);
		moveCursorTo (ixRowCursor);
		}
	
	for (var x in userOptions) {
		options [x] = userOptions [x];
		}
	
	function getListForCategory () { //10/12/22 by DW
		const catname = stringLower (options.catname);
		if ((catname === undefined) || (catname.length == 0) || (catname == "all")) {
			return (theList);
			}
		else {
			let newList = new Array ();
			theList.forEach (function (theFeed) {
				theFeed.categories.forEach (function (theCat) {
					if (theCat == catname) {
						newList.push (theFeed);
						}
					});
				});
			return (newList);
			}
		}
	theList = getListForCategory ();
	
	function getTimeString (when) {
		var s = getFacebookTimeString (when);
		s = replaceAll (s, "Just now", "now");
		return (s);
		}
	function encode (s) { //8/11/21 by DW
		s = encodeXml (s);
		s = replaceAll (s, "'", "&" + "quot;"); //10/15/21 by DW
		return (s);
		}
	function getOpmlLink () {
		var url;
		if (options.opmlUrlSpecial === undefined) {
			if (options.urlForOpmlLink === undefined) {
				url = "/opml?screenname=" + encodeURIComponent (options.opmlUrlName);
				if (options.catname !== undefined) { //10/6/23 by DW
					url += "&catname=" + encodeURIComponent (stringLower (options.catname));
					}
				}
			else {
				url = options.urlForOpmlLink;
				}
			}
		else {
			switch (options.opmlUrlSpecial) {
				case "hotlist": 
					url = "/opmlhotlist";
					break;
				}
			}
		var xmlIcon = $("<div class=\"divFeedlistOpmlLink\"><a href=\"" + url + "\" target=\"_blank\"><div class=\"divXmlIcon\">XML</div></a></div>"); 
		addToolTip (xmlIcon, "Get the OPML for this list");
		return (xmlIcon);
		}
	function getFeedListExplain () {
		var divFeedListExplain = $("<div class=\"divFeedListExplain\"></div>");
		function getAddFeedButton () {
			var theButtonContainer = $("<div class=\"divAddFeedButton\"></div>");
			var theButton = $("<button class=\"btn\"><i class=\"fa fa-plus\"></i>&nbsp;&nbsp;Feed</button>");
			theButtonContainer.append (theButton);
			addToolTip (theButton, "Click here to subscribe to a single feed.");
			theButton.click (function (ev) {
				console.log ("button clicked");
				addToFeedsMenu ();
				theButton.blur ();
				});
			return (theButtonContainer);
			}
		var divRightColumn = $("<div class=\"divExplainRightColumn\"></div>");
		if (options.flOpmlLink) { //12/26/22 by DW
			divRightColumn.append (getOpmlLink ());
			}
		if (options.flAddFeedButton) { //12/26/22 by DW
			divRightColumn.append (getAddFeedButton ());
			}
		divFeedListExplain.append (divRightColumn);
		
		divFeedListExplain.append (getExplainText (options.title, options.description));
		return (divFeedListExplain);
		}
	function getColumnHeaders () {
		const chArrowDown = "<i class=\"iHeaderArrow fa fa-arrow-down\"></i>", chArrowUp = "<i class=\"iHeaderArrow fa fa-arrow-up\"></i>";
		var theHeaders = $("<tr class=\"trHeaderRow\"></tr>");
		function getClickableHeader (headertext, sortvalue, toolTipText, flAlignRight=false, extraClass="") {
			if (extraClass.length > 0) { //12/6/23 by DW
				extraClass += " ";
				}
			var theClass = (flAlignRight) ? " class=\"" + extraClass + "tdRight\"" : "";
			if (sortvalue == options.sortBy) {
				headertext = "<span class=\"spHighlightedHeader\">" + headertext + "</span>";
				}
			
			var th = $("<th" + theClass + "></th>");
			var thText = $("<span>" + headertext + "</span>");
			addToolTip (thText, toolTipText, "right");
			th.append (thText);
			
			$(th).click (function (ev) {
				if (options.sortBy == sortvalue) { //7/11/22 by DW -- click a header again to reverse the sort
					options.flReverseSort = !options.flReverseSort;
					}
				else {
					options.sortBy = sortvalue;
					options.flReverseSort = false;
					}
				sortTheList ();
				buildTheFeedViewer ();
				appPrefs.sortFeedListBy = sortvalue;
				appPrefs.sortFeedReverse = options.flReverseSort;
				prefsChanged ();
				});
			return (th);
			}
		$(theHeaders).append ("<th></th>");
		if (options.flCheckboxes) { //10/27/22 by DW
			$(theHeaders).append ("<th></th>");
			}
		
		if (options.flFeedNumbering) {
			$(theHeaders).append ("<th></th>");
			}
		
		$(theHeaders).append (getClickableHeader ("Title", "title", "Sort the list by the feed's title"));
		if (options.flWhenColumn) {
			$(theHeaders).append (getClickableHeader ("When", "whenUpdated", "Sort list by when the feed last updated", true));
			}
		$(theHeaders).append (getClickableHeader ("Ct", "ctSubs", "Sort list by the number of subscribers", true, "notDisplayedOnMobile"));
		return (theHeaders);
		}
	function activateBootstrapStuff () {
		$("[data-toggle=\"popover\"]").popover ();
		activateToolTips ();
		}
	function saveExpandedFeedItems () { //9/3/22 by DW
		restorableItems = new Object ();
		$(".trRecentItems").each (function () {
			var feedUrl = $(this).attr ("data-feedurl");
			restorableItems [feedUrl] = this;
			});
		}
	function restoreExpandedFeedItems () {
		for (var feedUrlToBeRestored in restorableItems) {
			$(".trFeed").each (function () {
				var feedUrl = $(this).attr ("data-feedurl");
				if (feedUrl == feedUrlToBeRestored) {
					var theObject = restorableItems [feedUrl];
					this.after (theObject);
					$(this).trigger ("restoreWedge");
					}
				});
			}
		restorableItems = undefined;
		}
	
	function removeDuplicatesFromTheList () { //1/1/24 by DW
		var theNewList = new Array (), urlsWeAlreadyHave = new Object ();
		function buildUrlsWeAlreadyHave () {
			theList.forEach (function (feedRec) {
				if (feedRec.urlReadingList === undefined) { 
					urlsWeAlreadyHave [feedRec.feedUrl] = true;
					}
				});
			}
		function isUnique (feedRec) {
			if (urlsWeAlreadyHave [feedRec.feedUrl] === undefined) {
				return (true);
				}
			else {
				return (false);
				}
			}
		buildUrlsWeAlreadyHave ();
		theList.forEach (function (feedRec) {
			if (feedRec.urlReadingList === undefined) { 
				theNewList.push (feedRec);
				}
			else {
				if (isUnique (feedRec)) {
					theNewList.push (feedRec);
					}
				}
			});
		theList = theNewList;
		}
	
	
	function sortTheList () {
		function getCountForSorting (theCount) { //6/3/23 by DW
			if (theCount === undefined) {
				return (0);
				}
			else {
				return (theCount);
				}
			}
		function getDateForSorting (theDate) { //6/3/23 by DW
			if (theDate === undefined) {
				return (new Date (0));
				}
			else {
				return (new Date (theDate));
				}
			}
		theList.sort (function (a, b) {
			switch (options.sortBy) {
				case "title":
					var alower = trimWhitespace (a.title.toLowerCase ()), val; //9/30/23 by DW
					var blower = trimWhitespace (b.title.toLowerCase ());
					if (options.flReverseSort) { //7/11/22 by DW
						let tmp = alower;
						alower = blower;
						blower = tmp;
						}
					if (alower.length == 0) {
						return (1);
						}
					if (blower.length == 0) {
						return (-1);
						}
					if (alower == blower) {
						val = 0;
						}
					else {
						if (blower > alower) {
							val = -1;
							}
						else {
							val = 1;
							}
						}
					return (val);
				case "whenUpdated":
					var adate = getDateForSorting (a.whenUpdated), bdate = getDateForSorting (b.whenUpdated);
					if (options.flReverseSort) { //7/11/22 by DW
						let tmp = adate;
						adate = bdate;
						bdate = tmp;
						}
					return (bdate - adate);
				case "ctSubs":
					const acount = getCountForSorting (a.ctSubs), bcount = getCountForSorting (b.ctSubs);
					if (options.flReverseSort) { //7/11/22 by DW
						return (acount - bcount);
						}
					else {
						return (bcount - acount);
						}
				}
			});
		}
	
	function buildOneRow (theFeed, rownum) {
		var theRow = $("<tr class=\"trFeed\"></tr>");
		
		if (options.flHandleNavigationKeystrokes) { //12/27/22 by DW
			theRowArray.push (theRow);
			if (rownum == ixRowCursor) { 
				moveCursorTo (rownum);
				}
			}
		
		theRow.attr ("data-feedurl", theFeed.feedUrl);
		var flSubscribed = userIsSubscribed (theFeed.feedUrl), trClass = "";
		var tdWedge, flSubsAdded = false, flExpanded = false; 
		
		function appendCell (theObject) {
			if (theObject !== undefined) {
				theRow.append (theObject);
				}
			}
		function getFeedNumberCell () {
			return ($ ("<td class=\"tdFeedNumber\">" + (rownum + 1) + ".</td>"));
			}
		function getExpandableWedgeCell () {
			var flExpandInProgress = false; //10/26/22 by DW
			var theNewRow; //11/12/22 by DW -- moved it out to this level so we can delete it when collapsed
			function getFeedItemsForWedgeExpand (theFeed, maxItems, callback) { //6/2/23 by DW
				if (feedNotInDatabase (theFeed)) {
					const message = "Can't expand because feed isn't in the database.";
					callback ({message});
					}
				else {
					getFeedItems (theFeed.feedUrl, maxItems, callback);
					}
				}
			tdWedge = $("<td class=\"tdWedge\">" + rightCaret + "</td>");
			tdWedge.click (function () {
				const maxCharsItemText = 280, maxItems = 5;
				function expandItemList (displayError) {
					getFeedItemsForWedgeExpand (theFeed, maxItems, function (err, theItems) {
						if (err) {
							displayError (err.message);
							}
						else {
							function getItemText (item) {
								var itemtext = item.title;
								if (itemtext === undefined) {
									itemtext = maxStringLength (stripMarkup (item.description), maxCharsItemText, true, true);
									}
								return (itemtext);
								}
							theContainer = $("<div class=\"divRecentItems\"></div>");
							const theList = $("<ul class=\"ulRecentItems\"></ul>");
							
							if (theItems.length == 0) {
								const li = $("<li><div>" + options.thisFeedHasNoItemsString + "</div></il>");
								theList.append (li);
								}
							else {
								theItems.forEach (function (item, ix) {
									if (ix < maxItems) {
										var itemtext = getItemText (item), theLink = "";
										if (itemtext !== undefined) {
											if (item.pubDate !== undefined) { //10/20/22 by DW -- some items don't have a pubDate
												theLink = getUpdateableTime (item.pubDate, "", false, item.link);
												}
											else {
												if (item.link !== undefined) {
													theLink = "<a href=\"" + item.link + "\">Link</a>";
													}
												}
											const theContainer = $("<span class=\"spFeedItemWhenContainer\"></span>");
											theContainer.append (theLink);
											
											const li = $("<li><div></div></il>");
											li.append (itemtext);
											li.append (theContainer);
											theList.append (li);
											$(theLink).mouseenter (function (ev) {
												var popover = theLink;
												$(popover).data ("toggle", "popover");
												$(popover).data ("placement", "top");
												$(popover).data ("html", "true");
												
												const description = "<div class=\"divFeedItemPopover\">" + maxStringLength (item.description, 280, true, true) + "</div>"; 
												$(popover).data ("content", description);
												
												
												$(popover).popover ("show");
												});
											$(theLink).mouseleave (function (ev) {
												var popover = theLink;
												$(popover).data ("content", "");
												$(popover).popover ("hide");
												});
											}
										}
									});
								}
							
							
							
							theContainer.append (theList);
							
							theNewRow = $("<tr class=\"trRecentItems\"></tr>");
							theNewRow.attr ("data-feedurl", theFeed.feedUrl);
							theNewRow.append ($("<td colspan=\"2\"></td>"));
							var td = $("<td class=\"tdContainingFeedItems\" colspan=\"5\"></td>");
							td.append (theContainer);
							theNewRow.append (td);
							theRow.after (theNewRow);
							flSubsAdded = true;
							flExpanded = true;
							tdWedge.html (downCaret);
							}
						flExpandInProgress = false;
						bumpStartupCount (); //11/12/22 by DW
						});
					}
				if (flSubsAdded) {
					var theItems = $(theRow).next ();
					if (flExpanded) {
						theItems.css ("display", "none");
						tdWedge.html (rightCaret);
						flSubsAdded = false; //11/12/22 by DW
						if (theNewRow !== undefined) { //11/12/22 by DW
							theNewRow.remove (); 
							}
						}
					else {
						theItems.css ("display", "table-row");
						tdWedge.html (downCaret);
						}
					flExpanded = !flExpanded;
					}
				else {
					if (!flExpandInProgress) {
						flExpandInProgress = true;
						console.log (new Date ().toLocaleTimeString () + ": expanding " + theFeed.title);
						expandItemList (myAlertDialog);
						}
					}
				});
			
			
			return (tdWedge);
			}
		function getFeedTitle () {
			var theTd = getFeedTitleCell (theFeed);
			if (flSubscribed) {
				var optionalclass = "";
				if (!emptyCategories (theFeed.categories)) {
					optionalclass = " darkCategorySelector ";
					}
				var tag = $("<span class=\"spCategorySelector" + optionalclass + "\"><i class=\"fa fa-tag\"></i></span>"); //9/4/22 by DW
				
				var tooltiptext = ""; //10/6/23 by DW -- tooltip now shows categories already chosen
				if (theFeed.categories !== undefined) {
					theFeed.categories.forEach (function (catname) {
						tooltiptext += ((tooltiptext.length > 0) ? ", " : "") + catname;
						});
					}
				if (tooltiptext.length == 0) {
					tooltiptext = "Choose categories for feed";
					}
				addToolTip (tag, tooltiptext);
				
				tag.click (function () {
					chooseCategoriesDialog (theList, rownum, tag);
					});
				theTd.append (tag);
				}
			return (theTd);
			}
		function getXmlLinkCell () {
			return ($ ("<td>" + xmlViewerLink (theFeed.feedUrl, feedIcon) + "</td>"));
			}
		function getSubsCountCell () {
			if (options.flSubsCount) { //12/13/20 by DW
				const ct = (theFeed.ctSubs === undefined) ? "" : theFeed.ctSubs; //6/2/23 by DW
				return ($ ("<td class=\"tdRight tdSubsCount\"><span id=\"idCount" + rownum + "\">" + ct + "</span></td>"));
				}
			else {
				return (undefined);
				}
			}
		function getPopoverHtml (theFeed) {
			var htmltext = "";
			function add (s) {
				htmltext += s;
				}
			function addRow (name, value, flHtmltext=false) {
				if (value == null) {
					console.log (name + " is null");
					}
				if (value !== undefined) {
					value = value.toString ();
					if (value.length > 0) {
						add ("<tr>");
						if (!endsWith (name, "?")) {
							name += ":";
							}
						add ("<td>" + name + "&nbsp;</td>");
						
						const valuetext = (flHtmltext) ? value : encode (value); //10/29/23 by DW
						add ("<td class=\"tdRight\">" + valuetext + "</td>");
						
						add ("</tr>");
						}
					}
				}
			function addLine (theLine) {
				if (theLine !== undefined) {
					add ("<tr><td colspan=\"2\">" + addPeriodAtEnd (theLine) + "</td></tr>");
					}
				}
			function addSpacer () {
				}
			function getReadingList (callback) {
				if (theFeed.urlReadingList !== undefined) {
					if (readingListCache [theFeed.urlReadingList] !== undefined) {
						callback (undefined, readingListCache [theFeed.urlReadingList]);
						}
					else {
						getReadingListInfo (theFeed.urlReadingList, function (err, theList) {
							if (err) {
								callback (err);
								}
							else {
								readingListCache [theFeed.urlReadingList] = theList;
								callback (undefined, theList);
								}
							});
						}
					}
				else {
					callback ();
					}
				}
			function getReadingListLink () { //10/29/23 by DW
				const fname = stringLastField (theFeed.urlReadingList, "/");
				const id = "idReadingListLink";
				const htmltext = "<span id=\"" + id + "\">" + fname + "</span>";
				console.log ("getReadingListLink: id == " + id);
				getReadingList (function (err, theReadingList) {
					var theText = "";
					if (err) {
						theText = "error";
						}
					else {
						theText = theReadingList.title;
						}
					
					setTimeout (function () { //see comment at head of function -- 10/30/23 by DW
						$("#" + id).text (theText);
						}, 10);
					
					});
				return (htmltext);
				}
			add ("<table class=\"feedInfoTable table\">");
			
			if (theFeed.ctSubs === undefined) { //6/2/23 by DW
				addLine (theFeed.description);
				}
			else {
				addRow ("Subscribers", theFeed.ctSubs);
				addRow ("Checks", theFeed.ctChecks);
				addRow ("Items", theFeed.ctItems);
				if (theFeed.ctErrors > 0) {
					addRow ("Errors", theFeed.ctErrors);
					if (theFeed.ctConsecutiveErrors > 0) {
						addRow ("Consec errors", theFeed.ctConsecutiveErrors);
						}
					}
				
				
				addRow ("When added", getTimeString (theFeed.whenCreated));
				addRow ("When updated", getTimeString (theFeed.whenUpdated));
				addRow ("When checked", getTimeString (theFeed.whenChecked));
				if (theFeed.ctErrors > 0) {
					if (theFeed.whenLastError != "1970-01-01T00:00:00.000Z") {
						addRow ("When last error", getTimeString (theFeed.whenLastError));
						}
					}
				
				if (theFeed.urlReadingList !== undefined) { //10/29/23 by DW
					addRow ("Reading list", getReadingListLink (), true);
					}
				
				if (theFeed.whoFirstSubscribed !== undefined) {
					addRow ("Who added", theFeed.whoFirstSubscribed);
					}
				addRow ("Secs to read", theFeed.ctSecs);
				add ("</table>");
				}
			
			return (htmltext);
			}
		function getFeedInfoCell () {
			function hidePopover (thePopover) {
				$(thePopover).data ("content", "");
				$(thePopover).popover ("hide");
				}
			var infoCell = $("<td class=\"tdInfoIcon\"></td>");
			var popover = $("<span></span>");
			
			const feedStatus = (theFeed.ctConsecutiveErrors > 0) ? "feedIsError" : "feedIsOk";
			popover.append ("<i class=\"fa fa-info-circle " + feedStatus + "\"></i>"); //2/19/24 by DW
			infoCell.append (popover);
			$(infoCell).mouseenter (function (ev) {
				var theText = getPopoverHtml (theFeed);
				$(popover).data ("toggle", "popover");
				$(popover).data ("placement", "right");
				$(popover).data ("html", "true");
				$(popover).data ("content", theText);
				$(popover).data ("title", "<span class=\"spPopoverTitle\">" + encode (theFeed.title) + "</span>");
				$(popover).popover ("show");
				});
			$(infoCell).mouseleave (function (ev) {
				hidePopover (popover);
				});
			$(infoCell).click (function (ev) {
				window.location.href = "?feedurl=" + encodeURIComponent (theFeed.feedUrl);
				});
			return (infoCell);
			}
		appendCell (getExpandableWedgeCell ());
		if (options.flCheckboxes) { //10/27/22 by DW
			appendCell (getCheckboxCell (theFeed));
			}
		if (options.flFeedNumbering) { //9/17/22 by DW -- how can the hotlist not have numbers
			appendCell (getFeedNumberCell ());
			}
		appendCell (getFeedTitle ()); 
		if (options.flWhenColumn) {
			appendCell (getWhenUpdatedCell (theFeed.whenUpdated, theFeed)); 
			}
		appendCell (getSubsCountCell ());
		appendCell (getFeedInfoCell ());
		
		$(theRow).on ("feedUpdate", function (ev, theUpdatedFeed, placeToStoreOptions) {
			if (theUpdatedFeed.feedUrl == theFeed.feedUrl) {
				for (var x in theUpdatedFeed) { //7/10/22 by DW
					theFeed [x] = theUpdatedFeed [x];
					}
				placeToStoreOptions.flFoundFeed = true;
				}
			});
		$(theRow).on ("restoreWedge", function () { //9/3/22 by DW
			flSubsAdded = true;
			flExpanded = true;
			tdWedge.html (downCaret);
			});
		$(theRow).click (function () { //12/28/22 by DW
			moveCursorTo (getRownum (theFeed.feedUrl));
			});
		
		return (theRow);
		}
	function buildContainer () { //9/23/22 by DW
		
		var extraClass = "";
		if (options.extraContainerClass !== undefined) { //12/7/23 by DW
			extraClass = " " + options.extraContainerClass;
			}
		
		var divFeedListContainer = $("<div class=\"divFeedListContainer" + extraClass + "\"></div>"); //12/7/23 by DW
		if (options.flIncludeExplain) { //12/26/22 by DW
			divFeedListContainer.append (getFeedListExplain ());
			}
		if (options.searchbox !== undefined) {
			divFeedListContainer.append (options.searchbox);
			}
		var divFeedList = $("<div class=\"divFeedList\"></div>");
		divFeedListContainer.append (divFeedList);
		
		if (options.whereToAppend === undefined) { //10/12/22 by DW
			options.whereToAppend = $(".divSignedOn");
			}
		
		options.whereToAppend.empty (); //10/12/22 by DW
		options.whereToAppend.append (divFeedListContainer);
		
		return (divFeedList);
		}
	function buildTheFeedViewer () {
		var theTable = $("<table class=\"table\"></table>");
		$(theTable).append (getColumnHeaders ()); //7/5/22 by DW
		theList.forEach (function (theFeed, i) {
			if (i <= options.maxItems) {
				if (theFeed.title != null) {
					theTable.append (buildOneRow (theFeed, i));
					}
				}
			});
		
		divFeedList.empty ();
		divFeedList.append (theTable);
		}
	function removeErrorFeeds () { //11/28/23 by DW
		var newList = new Array ();
		theList.forEach (function (item) {
			if (item.whenChecked !== undefined) {
				newList.push (item);
				}
			});
		theList = newList;
		}
	
	console.log ("viewFeedList");
	divFeedList = buildContainer (); //9/23/22 by DW
	removeDuplicatesFromTheList (); //1/1/24 by DW
	sortTheList ();
	removeErrorFeeds (); //11/28/23 by DW
	buildTheFeedViewer ();
	activateBootstrapStuff ();
	
	var handle = $("<div></div>");
	$(handle).on ("feedUpdate", function (event, theUpdatedFeed) {
		var placeToStoreOptions = {flFoundFeed: false};
		$(".divFeedList table tr").trigger ("feedUpdate", [theUpdatedFeed, placeToStoreOptions]);
		if (placeToStoreOptions.flFoundFeed !== undefined) {
			
			saveCursor (); //12/28/22 by DW
			saveExpandedFeedItems (); //9/3/22 by DW
			sortTheList ();
			buildTheFeedViewer ();
			restoreExpandedFeedItems (); 
			restoreCursor ();
			activateBootstrapStuff ();
			}
		});
	
	if (options.flHandleNavigationKeystrokes) { //12/27/22 by DW
		$("body").keydown (function (ev) { //12/27/22 by DW
			
			if ($("#idPrefsDialog").css ("display") == "none") {
				if ($(".divAskDialog").length == 0) {
					if ($(".divOutlineDialogOutline").length == 0) { //9/30/23 by DW
						let flconsume = false; //9/30/23 by DW
						switch (ev.which) {
							case 13:
								toggleExpand ();
								flconsume = true;
								break;
							case 38: 
								moveCursorUp ();
								flconsume = true;
								break;
							case 40: 
								moveCursorDown ();
								flconsume = true;
								break;
							}
						if (flconsume) {
							ev.stopPropagation ();
							ev.preventDefault ();
							}
						}
					}
				}
			});
		}
	
	return (handle);
	}

function viewUserPage (screenname, catname, whereToAppend) {
	const myname = getScreenName ();
	var subsToDisplay; //the subscriptions list we're displaying
	var usersSubs; //the subscriptions of the current user
	
	function getSubs (callback) {
		usersSubs = globals.userSubscriptions;
		if (screenname == myname) {
			subsToDisplay = usersSubs;
			callback (undefined);
			}
		else {
			getSubscriptions (screenname, function (err, theSubs) {
				if (err) {
					callback (err);
					}
				else {
					subsToDisplay = theSubs;
					callback ();
					}
				});
			}
		}
	getSubs (function (err) { //sets subsToDisplay and usersSubs
		if (err) {
			alertDialog ("Can't display the list because there was an error: " + err.message);
			}
		else {
			var addFeedButton = "";
			if (screenname == myname) { //viewing page with your own subs
				addFeedButton = "<div class=\"divAddFeedButton\"><button class=\"btn\" onclick=\"subscribeCommand ()\"><i class=\"fa fa-plus\"></i>&nbsp;&nbsp;Feed</button></div>";
				}
			
			var titletext = screenname + " > feeds";
			if (catname !== undefined) {
				titletext += " > " + catname;
				}
			
			
			var options = {
				mySubs: usersSubs,
				sortBy: appPrefs.sortFeedListBy,
				flReverseSort: appPrefs.sortFeedReverse,
				title: titletext, //10/6/23 by DW
				opmlUrlName: screenname,
				description: "A list of feeds that " + linkToRiverPage (screenname, catname) + " is subscribed to.",
				whereToAppend, //10/12/22 by DW
				catname //10/12/22 by DW
				};
			
			currentFeedlist = viewFeedlist (subsToDisplay, options);
			$("#idFeedlistExplain").html ("<h1>" + screenname + "'s subs</h1><p>" + addFeedButton + "Here's a list of the feeds that " + linkToRiverPage (screenname, catname) + " is subscribed to.</p>");
			
			if (screenname == myname) { //10/30/22 by DW
				if (subsToDisplay.length < 10) {
					if (appPrefs.flCanOfferToAddFeeds) {
						assureCanAddNewAccounts (); //12/12/22 by DW -- doesn't return if it can't
						addAFewFeeds ();
						}
					}
				appPrefs.flCanOfferToAddFeeds = false;
				prefsChanged ();
				}
			}
		
		});
	}
function viewHotlist () {
	const maxHotlistItems = 100;
	getHotlist (function (err, theHotlist) {
		if (err) {
			myAlertDialog (err.message);
			}
		else {
			var options = {
				mySubs: globals.userSubscriptions,
				maxItems: maxHotlistItems,
				sortBy: "ctSubs", //it's the hotlist after all
				flReverseSort: false,
				title: "The FeedLand Hotlist",
				opmlUrlSpecial: "hotlist",
				description: "The " + maxHotlistItems + " most popular feeds in FeedLand.",
				flWhenColumn: false, //include the When column
				flFeedNumbering: true, //9/17/22 by DW
				extraContainerClass: "divHotlistContainer" //12/7/23 by DW
				};
			viewFeedlist (theHotlist, options)
			}
		});
	}
function viewHotlistInMarkdown () {
	getHotlist (function (err, theHotlist) {
		if (err) {
			myAlertDialog (err.message);
			}
		else {
			const pipe = " | ";
			var mdtext = "";
			function add (s) {
				mdtext += s + "\r\n";
				}
			add ("## The FeedLand Hotlist");
			add ("### The 100 most popular feeds in FeedLand.");
			add ("")
			add ("| ix | Website | Feed | Count |");
			add ("|:-----:| ----- | ----- |:-----:|");
			theHotlist.forEach (function (item, ix) {
				const titlestring = maxStringLength (item.title, 30, false, true);
				const title = replaceAll (titlestring, "|", "-");
				const htmllink = "[" + title + "](" + item.htmlUrl + ")";
				const feedlink = "[feed](" + item.feedUrl + ")";
				add ("| " + (ix + 1) + ". | " + htmllink + " | " + feedlink + " | " + item.ctSubs + " | ");
				})
			console.log (mdtext);
			}
		});
	}
function viewFeedSearch (searchfor="") { //12/26/22 by DW
	var feedSearchOptions = {
		title: "Search results",
		description: "Finally we have a search command for feeds.",
		mySubs: globals.userSubscriptions,
		maxItems: 100,
		sortBy: "ctSubs", 
		flReverseSort: false,
		opmlUrlSpecial: "hotlist",
		flWhenColumn: true, 
		flFeedNumbering: true,
		flIncludeExplain: true,
		searchbox: getSearchBox (searchfor),
		flOpmlLink: false,
		flAddFeedButton: false,
		flHandleNavigationKeystrokes: false
		};
	function pushState (searchfor) {
		var state = {
			searchfor
			};
		history.pushState (state, "", "/?search=" + encodeURIComponent (searchfor));
		}
	function doSearch (searchfor) {
		pushState (searchfor);
		getFeedSearch (searchfor, function (err, theSearchResults) {
			if (err) {
				myAlertDialog (err.message);
				}
			else {
				viewFeedlist (theSearchResults, feedSearchOptions)
				}
			});
		}
	function getSearchBox (searchfor) {
		var theSearchBox = $("<div class=\"divSearchBox\"></div>");
		var theInput = $("<input type=\"text\" class=\"input-xlarge\">");
		var theButton = $("<button class=\"btn\">Go</button>");
		theSearchBox.append (theInput);
		theSearchBox.append (theButton);
		theInput.val (searchfor);
		theInput.keydown (function (ev) {
			if (ev.which == 13) {
				doSearch (theInput.val ());
				}
			});
		theButton.click (function () {
			doSearch (theInput.val ());
			});
		return (theSearchBox);
		}
	doSearch (searchfor);
	window.addEventListener ("popstate", function (ev) {
		if (ev.state != null) { //1/4/23 by DW -- it can happen
			doSearch (ev.state.searchfor);
			}
		});
	}
function viewSubscriptionList (urlOpml) { //6/2/23 by DW
	getFeedlistFromOpml (urlOpml, function (err, theFeedlist, theOutlineHead) {
		if (err) {
			alertDialog (err.message);
			}
		else {
			var options = {
				title: theOutlineHead.title,
				description: theOutlineHead.description,
				mySubs: globals.userSubscriptions,
				sortBy: "title", 
				flReverseSort: false,
				flWhenColumn: true, 
				flFeedNumbering: false,
				flIncludeExplain: true,
				searchbox: undefined,
				flOpmlLink: true,
				urlForOpmlLink: urlOpml, 
				flAddFeedButton: false,
				};
			viewFeedlist (theFeedlist, options)
			}
		});
	}
function updateFeedlistFeed (theFeed) {
	$(currentFeedlist).trigger ("feedUpdate", [theFeed]);
	}
function feedlistEveryMinute () { //7/27/22 by DW
	$(".tdFeedUpdated").trigger ("update");
	}


//blogroll.js
function blogroll (userOptions) {
	console.log ("blogroll");
	var options = {
		whereToAppend: $(".divBlogrollContainer"),
		title: appConsts.productnameForDisplay,
		flDisplayTitle: false,
		maxTitleLength: 25,
		sortBy: "whenUpdated",
		flReverseSort: false,
		maxCharsItemText: 200,
		flEllipsesAfterText: false,
		ixcursor: 0,
		urlFeedListOpml: undefined,
		maxDaysInBlogroll: Infinity,
		flSortLinks: true, //2/19/24 by DW
		cursorMovedCallback: function (ixcursor) {
			},
		sortOptionsChangedCallback: function (sortBy, flReverseSort) {
			},
		blogrollDisplayedCallback: function () {
			}
		};
	function copyUserOptions (userOptions) {
		if (userOptions !== undefined) {
			for (x in userOptions) {
				if (userOptions [x] !== undefined) {
					options [x] = userOptions [x];
					}
				}
			}
		}
	copyUserOptions (userOptions);
	
	var theTable = undefined;
	const whenstart = new Date ();
	
	function openFeedlandSocket (userOptions) { //2/11/24 by DW
		var options = {
			feedUpdatedCallback: function (theFeed) {
				}
			};
		if (userOptions !== undefined) {
			for (var x in userOptions) {
				if (userOptions [x] !== undefined) {
					options [x] = userOptions [x];
					}
				}
			}
		var mySocket = undefined;
		function checkConnection () {
			if (mySocket === undefined) {
				mySocket = new WebSocket (appConsts.urlSocketServer); 
				mySocket.onopen = function (evt) {
					const s = "hello world";
					console.log ("openFeedlandSocket: sending: " + s);
					mySocket.send (s);
					};
				mySocket.onmessage = function (evt) {
					function getPayload (jsontext) {
						var thePayload = undefined;
						try {
							thePayload = JSON.parse (jsontext);
							}
						catch (err) {
							}
						return (thePayload);
						}
					if (evt.data !== undefined) { //no error
						var theCommand = stringNthField (evt.data, "\r", 1);
						var jsontext = stringDelete (evt.data, 1, theCommand.length + 1);
						var thePayload = getPayload (jsontext);
						switch (theCommand) {
							case "updatedFeed":
								if (appConsts.flShowSocketMessages) {
									console.log (nowstring () + ": " + thePayload.title + ", id == " + thePayload.feedUrl);
									}
								options.feedUpdatedCallback (thePayload);
								break;
							}
						}
					};
				mySocket.onclose = function (evt) {
					mySocket = undefined;
					};
				mySocket.onerror = function (evt) {
					};
				}
			}
		self.setInterval (checkConnection, 1000);
		}
	function getTheFeedList (urlFeedListOpml, callback) {
		getFeedlistFromOpml (urlFeedListOpml, function (err, theFeedlist, theOutlineHead) {
			if (err) {
				callback (err);
				}
			else {
				callback (undefined, theFeedlist);
				}
			});
		}
	function getFeedItemsForWedgeExpand (theFeed, maxItems, callback) { 
		if (feedNotInDatabase (theFeed)) {
			const message = "Can't expand because feed isn't in the database.";
			callback ({message});
			}
		else {
			getFeedItems (theFeed.feedUrl, maxItems, callback);
			}
		}
	function viewBlogroll (theList) {
		
		const cursorClass = "trBlogrollCursor";
		const rightCaret = "<i class=\"fa fa-caret-right darkCaretColor\"></i>";
		const downCaret = "<i class=\"fa fa-caret-down lightCaretColor\"></i>";
		const uparrowChar = "<i class=\"fa fa-arrow-up\"></i>";
		const downarrowChar = "<i class=\"fa fa-arrow-down\"></i>";
		
		function getCursorRow () {
			const cursorRow = $("." + cursorClass);
			return (cursorRow);
			}
		function cursorUp () {
			const cursorRow = getCursorRow ();
			const newCursorRow = cursorRow.prev ();
			if ((newCursorRow.length == 0) || (newCursorRow.hasClass ("trHeaderRow"))) { //don't put cursor on column header row
				speakerBeep ();
				return (false); //couldn't move
				}
			else {
				cursorRow.removeClass (cursorClass);
				newCursorRow.addClass (cursorClass);
				options.cursorMovedCallback (newCursorRow.index ());
				return (true);
				}
			}
		function cursorDown () {
			const cursorRow = getCursorRow ();
			const newCursorRow = cursorRow.next ();
			if (newCursorRow.length == 0) {
				speakerBeep ();
				return (false); //couldn't move
				}
			else {
				cursorRow.removeClass (cursorClass);
				newCursorRow.addClass (cursorClass);
				options.cursorMovedCallback (newCursorRow.index ());
				return (true);
				}
			}
		function moveCursorToRow (theRow) { //2/16/24 by DW
			$("." + cursorClass).removeClass (cursorClass);
			theRow.addClass (cursorClass);
			options.cursorMovedCallback (theRow.index ());
			}
		
		theTable = $("<table class=\"divBlogroll\"></table>");
		const theTableBody = $("<tbody></tbody>");
		theTable.append (theTableBody);
		
		function appendTitleAboveTable () {
			if (options.flDisplayTitle) {
				const divBlogrollTitle = $("<div class=\"divBlogrollTitle\"></div>");
				
				const spLeftTitleArrow = $("<span class=\"spTitleArrow spTitleArrowLeft\">" + uparrowChar + "</span>");
				const spRightTitleArrow = $("<span class=\"spTitleArrow spTitleArrowRight\">" + uparrowChar + "</span>");
				
				divBlogrollTitle.append (spLeftTitleArrow);
				divBlogrollTitle.append ($("<span class=\"spTitleText\">" + options.title + "</span>"));
				divBlogrollTitle.append (spRightTitleArrow);
				
				options.whereToAppend.append (divBlogrollTitle);
				}
			}
		function appendSortLinksAboveTable () { //2/19/24 by DW
			if (options.flSortLinks) {
				const divBlogrollSortLinks = $("<div class=\"divBlogrollSortLinks\"></div>");
				const spTitleLink = $("<span class=\"spTitleLink\">Title</span>");
				const spWhenLink = $("<span class=\"spWhenLink\">When</span>");
				divBlogrollSortLinks.append (spTitleLink);
				divBlogrollSortLinks.append (spWhenLink);
				setSelectedLink ();
				options.whereToAppend.append (divBlogrollSortLinks);
				
				function setSelectedLink () {
					if (options.sortBy == "title") {
						spTitleLink.addClass ("selected");
						spWhenLink.removeClass ("selected");
						}
					else {
						spWhenLink.addClass ("selected");
						spTitleLink.removeClass ("selected");
						}
					}
				function handleClick (sortByValue) {
					if (options.sortBy == sortByValue) {
						options.flReverseSort = !options.flReverseSort;
						}
					else {
						options.sortBy = sortByValue;
						options.flReverseSort = false;
						}
					setSelectedLink ();
					buildTheTable ();
					options.sortOptionsChangedCallback (options.sortBy, options.flReverseSort);
					}
				
				spTitleLink.click (function () {
					handleClick ("title");
					});
				spWhenLink.click (function () {
					handleClick ("whenUpdated");
					});
				}
			}
		function buildTheTable () {
			const whenstart = new Date ();
			const maxsecs = options.maxDaysInBlogroll * 60 * 60 * 24;
			theTableBody.empty ();
			theList.sort (function (a, b) {
				function getDateForSorting (theDate) {
					if (theDate === undefined) {
						return (new Date (0));
						}
					else {
						return (new Date (theDate));
						}
					}
				switch (options.sortBy) {
					case "title":
						var alower = trimWhitespace (a.title.toLowerCase ()), val; //9/30/23 by DW
						var blower = trimWhitespace (b.title.toLowerCase ());
						if (options.flReverseSort) { //7/11/22 by DW
							let tmp = alower;
							alower = blower;
							blower = tmp;
							}
						if (alower.length == 0) {
							return (1);
							}
						if (blower.length == 0) {
							return (-1);
							}
						if (alower == blower) {
							val = 0;
							}
						else {
							if (blower > alower) {
								val = -1;
								}
							else {
								val = 1;
								}
							}
						return (val);
					case "whenUpdated":
						var adate = getDateForSorting (a.whenUpdated), bdate = getDateForSorting (b.whenUpdated);
						if (options.flReverseSort) { //7/11/22 by DW
							let tmp = adate;
							adate = bdate;
							bdate = tmp;
							}
						return (bdate - adate);
					}
				});
			theList.forEach (function (theFeed, ix) {
				if (secondsSince (theFeed.whenUpdated) <= maxsecs) {
					var divNewsPod, tdWedge, spTimeContainer;
					const theClass = (ix == options.ixcursor) ? " trBlogrollCursor " : "";
					const theRow = $("<tr class=\"trBlogrollFeed" + theClass + "\"></tr>");
					theRow.attr ("data-feedurl", theFeed.feedUrl);
					
					function expandToggle () {
						if (divNewsPod.css ("display") == "none") {
							getFeedItemsForWedgeExpand (theFeed, 5, function (err, theItems) {
								if (err) {
									alertDialog (err.message);
									}
								else {
									const itemList = $("<ul class=\"ulFeedItems\"></ul>");
									theItems.forEach (function (item) {
										function getItemText (item) {
											var itemtext = item.title;
											if (itemtext === undefined) {
												itemtext = maxStringLength (stripMarkup (item.description), options.maxCharsItemText, true, options.flEllipsesAfterText);
												}
											itemtext = trimWhitespace (itemtext);
											
											if (options.flEllipsesAfterText) {
												if (itemtext.length > 0) {
													if (!isPunctuation (itemtext [itemtext.length - 1])) {
														itemtext += ".";
														}
													}
												}
											
											return (itemtext);
											}
										const feedItem = $("<li class=\"liFeedItem\"></li>");
										
										const itemtext = getItemText (item);
										feedItem.append ($("<span>" + itemtext + "</span>"));
										
										const spItemPubdate = $("<span class=\"spItemPubdate\"> </span>"); //by adding a space here, we allow it to wrap before the date --2/16/24 by DW
										const theLink = $("<a href=\"" + item.link + "\" target=\"_blank\" data-pubDate=\"" + item.pubDate + "\">" + getFeedlandTimeString (item.pubDate, false) + "</a>");
										spItemPubdate.append (theLink);
										feedItem.append (spItemPubdate);
										
										addToolTip (spItemPubdate, itemtext, "top");
										
										
										feedItem.click (function (ev) {
											console.log (itemtext);
											console.log (jsonStringify (item));
											viewFeedItemInEditor (item, theFeed);
											ev.stopPropagation ();
											});
										itemList.append (feedItem);
										});
									divNewsPod.empty ();
									divNewsPod.append (itemList);
									divNewsPod.css ("visibility", "hidden")
									divNewsPod.css ("display", "block")
									divNewsPod.slideDown (75, undefined, function () {
										tdWedge.html (downCaret);
										divNewsPod.css ("visibility", "visible")
										theFeed.flExpanded = true;
										activateToolTips ();
										});
									}
								});
							}
						else {
							divNewsPod.css ("display", "none")
							tdWedge.html (rightCaret);
							theFeed.flExpanded = false;
							}
						}
					function getTimeString (when) {
						var whenstring = getFeedlandTimeString (new Date (when), false);
						if (endsWith (whenstring, " mins")) { //this gives us back one char in each line, because this is the longest whenstring -- 2/16/24 by DW
							whenstring = stringDelete (whenstring, whenstring.length, 1);
							}
						return ("<span class=\"spWhenUpdated\">" + whenstring + "</span>");
						}
					function setDataThatCanChange () { //2/12/24 by DW
						
						
						spTimeContainer.html (getTimeString (theFeed.whenUpdated));
						
						divNewsPod.find ("ul li span.spItemPubdate a").each (function () {
							const pubdateatt = $(this).attr ("data-pubDate");
							const newstring = getFeedlandTimeString (pubdateatt, false);
							$(this).text (newstring);
							});
						
						
						}
					function getWedge () {
						tdWedge = $("<td class=\"tdBlogrollWedge\">" + rightCaret + "</td>");
						tdWedge.click (function (ev) {
							expandToggle ();
							moveCursorToRow (theRow); //2/16/24 by DW
							ev.stopPropagation ();
							});
						return (tdWedge);
						}
					function getFeedTitle () {
						const td = $("<td class=\"tdBlogrollFeedTitle\"></td>");
						
						spTimeContainer = $("<span class=\"spTimeContainer\">" + getTimeString (theFeed.whenUpdated) + "</span>");
						td.append (spTimeContainer);
						
						var titleString = trimWhitespace (maxStringLength (theFeed.title, options.maxTitleLength, false, true));
						if (titleString.length == 0) {
							titleString = "[empty]";
							}
						
						const spTitleString = $("<span class=\"spTitleString\">" + titleString + "</span>");
						td.append (spTitleString);
						addToolTip (spTitleString, theFeed.description);
						
						divNewsPod = $("<div class=\"divNewsPod\"></div>");
						td.append (divNewsPod);
						
						return (td);
						}
					function getWhenUpdated () {
						const tdWhenUpdated = $("<td class=\"tdMyFeedWhenUpdated\"></td>");
						tdWhenUpdated.append (getUpdateableTime (theFeed.whenUpdated, "", false));
						return (tdWhenUpdated);
						}
					theRow.append (getWedge ());
					theRow.append (getFeedTitle ());
					theRow.click (function (ev) {
						const flCursorMoves = !theRow.hasClass (cursorClass);
						if (flCursorMoves) {
							moveCursorToRow (theRow);
							console.log (theFeed);
							}
						else { //second click
							expandToggle ();
							}
						});
					theRow.mousedown (function (ev) {
						ev.preventDefault ();
						});
					theTableBody.append (theRow);
					
					if (getBoolean (theFeed.flExpanded)) { //2/13/24 by DW
						expandToggle ();
						}
					
					theRow.on ("expandToggle", expandToggle);
					theRow.on ("dataChanged", function (ev, theNewFeed) {
						if (theNewFeed !== undefined) {
							theFeed = theNewFeed;
							}
						setDataThatCanChange ();
						});
					}
				});
			}
		
		appendSortLinksAboveTable (); //2/19/24 by DW
		appendTitleAboveTable (); //2/17/24 by DW
		buildTheTable ();
		options.whereToAppend.append (theTable);
		activateToolTips (); //2/19/24 by DW
		
		function handleFeedUpdated (theFeed) {
			var flfound = false, ixmatch = undefined, theMatchedFeed = undefined;
			theList.forEach (function (item, ix) {
				if (!flfound) {
					if (item.feedUrl == theFeed.feedUrl) {
						ixmatch = ix;
						theMatchedFeed = item;
						flfound = true;
						}
					}
				});
			if (flfound) { //it's one that we're watching
				if (appConsts.flBlogrollUpdates) {
					console.log (nowstring () + ": " + theFeed.title + ", theFeed.feedUrl == " + theFeed.feedUrl);
					console.log (theFeed);
					theMatchedFeed.whenUpdated = theFeed.whenUpdated;
					
					buildTheTable ();
					activateToolTips (); //2/19/24 by DW
					
					}
				}
			}
		
		theTable.on ("feedUpdated", function (ev, params) { //2/12/24 by DW
			handleFeedUpdated (params.theFeed);
			});
		theTable.on ("buildBlogroll", function () { //2/19/24 by DW
			buildTheTable ();
			activateToolTips (); 
			});
		
		const socketOptions = {
			feedUpdatedCallback: function (theFeed) {
				handleFeedUpdated (theFeed);
				}
			};
		openFeedlandSocket (socketOptions); //2/11/24 by DW
		
		$("body").keydown (function (ev) {
			var flconsumed = false;
			switch (ev.which) {
				case 13: //return
					getCursorRow ().trigger ("expandToggle");
					flconsumed = true;
					break;
				case 38: //up arrow
					cursorUp ();
					flconsumed = true;
					break;
				case 40: //down arrow
					cursorDown ();
					flconsumed = true;
					break;
				}
			if (flconsumed) {
				ev.preventDefault ();
				}
			});
		
		runEveryMinute (function () {
			$(".divBlogroll tr").trigger ("dataChanged");
			});
		}
	
	if (options.urlFeedListOpml === undefined) {
		console.log ("Can't display the blogroll because options.urlFeedListOpml was not specified.");
		}
	else {
		getTheFeedList (options.urlFeedListOpml, function (err, theList) {
			if (err) {
				console.log ("startBlogroll: err.message == " + err.message);
				}
			else {
				const whenstartbuild = new Date ();
				viewBlogroll (theList);
				console.log ("blogroll: " + secondsSince (whenstartbuild) + " secs to build the viewer.");
				options.blogrollDisplayedCallback ();
				}
			});
		}
	
	this.buildBlogroll = function (userOptions) {
		console.log ("buildBlogroll: userOptions == " + jsonStringify (userOptions));
		copyUserOptions (userOptions);
		theTable.trigger ("buildBlogroll");
		};
	}

